# Code generated by qwick.

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, Namespace
from ebcc.precision import types

def energy(f=None, v=None, nocc=None, nvir=None, naux=None, t1=None, t2=None, **kwargs):
    # energy
    x0 = np.zeros((naux,), dtype=types[float])
    x0 += einsum(t1.bb, (0, 1), v.abb.xov, (2, 0, 1), (2,))
    x1 = np.zeros((naux,), dtype=types[float])
    x1 += einsum(t1.aa, (0, 1), v.aaa.xov, (2, 0, 1), (2,))
    x1 += einsum(x0, (0,), (0,)) * 2.0
    x2 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x2 += einsum(v.aaa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 4, 0))
    x2 += einsum(v.abb.xov, (0, 1, 2), t2.abab, (3, 1, 4, 2), (3, 4, 0))
    x2 += einsum(x1, (0,), t1.aa, (1, 2), (1, 2, 0)) * 0.5
    del x1
    e_cc = 0
    e_cc += einsum(v.aaa.xov, (0, 1, 2), x2, (1, 2, 0), ())
    del x2
    x3 = np.zeros((nocc[0], nocc[0], naux), dtype=types[float])
    x3 += einsum(t1.aa, (0, 1), v.aaa.xov, (2, 3, 1), (0, 3, 2))
    x4 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x4 += einsum(f.aa.ov, (0, 1), (0, 1)) * 2.0
    x4 += einsum(v.aaa.xov, (0, 1, 2), x3, (1, 3, 0), (3, 2)) * -1.0
    del x3
    e_cc += einsum(t1.aa, (0, 1), x4, (0, 1), ()) * 0.5
    del x4
    x5 = np.zeros((nocc[1], nocc[1], naux), dtype=types[float])
    x5 += einsum(t1.bb, (0, 1), v.abb.xov, (2, 3, 1), (0, 3, 2))
    x6 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x6 += einsum(f.bb.ov, (0, 1), (0, 1))
    x6 += einsum(v.abb.xov, (0, 1, 2), x5, (1, 3, 0), (3, 2)) * -0.5
    del x5
    e_cc += einsum(t1.bb, (0, 1), x6, (0, 1), ())
    del x6
    x7 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x7 += einsum(v.abb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (3, 4, 0))
    x7 += einsum(x0, (0,), t1.bb, (1, 2), (1, 2, 0)) * 0.5
    del x0
    e_cc += einsum(v.abb.xov, (0, 1, 2), x7, (1, 2, 0), ())
    del x7

    return e_cc

def update_amps(f=None, v=None, nocc=None, nvir=None, naux=None, t1=None, t2=None, **kwargs):
    t1new = Namespace()
    t2new = Namespace()

    # T amplitudes
    t1new_aa = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    t1new_aa += einsum(f.aa.ov, (0, 1), (0, 1))
    t1new_aa += einsum(f.aa.vv, (0, 1), t1.aa, (2, 1), (2, 0))
    t1new_bb = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    t1new_bb += einsum(f.bb.vv, (0, 1), t1.bb, (2, 1), (2, 0))
    t1new_bb += einsum(f.bb.ov, (0, 1), (0, 1))
    x0 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x0 += einsum(t1.aa, (0, 1), v.aaa.xoo, (2, 3, 0), (3, 1, 2))
    x1 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x1 += einsum(v.abb.xov, (0, 1, 2), t2.abab, (3, 1, 4, 2), (3, 4, 0))
    x2 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x2 += einsum(t2.aaaa, (0, 1, 2, 3), (0, 1, 2, 3))
    x2 += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -0.5
    x3 = np.zeros((naux,), dtype=types[float])
    x3 += einsum(t1.aa, (0, 1), v.aaa.xov, (2, 0, 1), (2,))
    x4 = np.zeros((naux,), dtype=types[float])
    x4 += einsum(t1.bb, (0, 1), v.abb.xov, (2, 0, 1), (2,))
    x5 = np.zeros((naux,), dtype=types[float])
    x5 += einsum(x3, (0,), (0,))
    del x3
    x5 += einsum(x4, (0,), (0,))
    del x4
    x6 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x6 += einsum(x0, (0, 1, 2), (0, 1, 2)) * -1.0
    x6 += einsum(x1, (0, 1, 2), (0, 1, 2))
    x6 += einsum(v.aaa.xov, (0, 1, 2), x2, (1, 3, 2, 4), (3, 4, 0)) * 2.0
    del x2
    x6 += einsum(x5, (0,), t1.aa, (1, 2), (1, 2, 0))
    t1new_aa += einsum(v.aaa.xvv, (0, 1, 2), x6, (3, 2, 0), (3, 1))
    del x6
    x7 = np.zeros((nocc[0], nocc[0], naux), dtype=types[float])
    x7 += einsum(t1.aa, (0, 1), v.aaa.xov, (2, 3, 1), (0, 3, 2))
    x8 = np.zeros((nocc[0], nocc[0], naux), dtype=types[float])
    x8 += einsum(v.aaa.xoo, (0, 1, 2), (1, 2, 0))
    x8 += einsum(x7, (0, 1, 2), (0, 1, 2))
    x9 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x9 += einsum(v.abb.xov, (0, 1, 2), x8, (3, 4, 0), (4, 3, 1, 2))
    t1new_aa += einsum(t2.abab, (0, 1, 2, 3), x9, (0, 4, 1, 3), (4, 2)) * -1.0
    del x9
    x10 = np.zeros((nocc[0], nocc[0], naux), dtype=types[float])
    x10 += einsum(v.aaa.xoo, (0, 1, 2), (1, 2, 0))
    x10 += einsum(x7, (0, 1, 2), (1, 0, 2))
    x11 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x11 += einsum(v.aaa.xov, (0, 1, 2), x10, (3, 4, 0), (1, 3, 4, 2))
    t1new_aa += einsum(t2.aaaa, (0, 1, 2, 3), x11, (0, 1, 4, 3), (4, 2)) * 2.0
    x12 = np.zeros((nocc[1], nocc[1], naux), dtype=types[float])
    x12 += einsum(t1.bb, (0, 1), v.abb.xov, (2, 3, 1), (0, 3, 2))
    x13 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x13 += einsum(v.abb.xov, (0, 1, 2), x12, (1, 3, 0), (3, 2))
    x14 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x14 += einsum(x5, (0,), v.abb.xov, (0, 1, 2), (1, 2))
    t1new_bb += einsum(x14, (0, 1), (0, 1))
    x15 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x15 += einsum(f.bb.ov, (0, 1), (0, 1))
    x15 += einsum(x13, (0, 1), (0, 1)) * -1.0
    x15 += einsum(x14, (0, 1), (0, 1))
    del x14
    t1new_aa += einsum(x15, (0, 1), t2.abab, (2, 0, 3, 1), (2, 3))
    t1new_bb += einsum(x15, (0, 1), t2.bbbb, (2, 0, 3, 1), (2, 3)) * 2.0
    x16 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x16 += einsum(v.aaa.xov, (0, 1, 2), x7, (1, 3, 0), (3, 2))
    x17 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x17 += einsum(x5, (0,), v.aaa.xov, (0, 1, 2), (1, 2))
    t1new_aa += einsum(x17, (0, 1), (0, 1))
    x18 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x18 += einsum(f.aa.ov, (0, 1), (0, 1))
    x18 += einsum(x16, (0, 1), (0, 1)) * -1.0
    x18 += einsum(x17, (0, 1), (0, 1))
    del x17
    t1new_aa += einsum(x18, (0, 1), t2.aaaa, (2, 0, 3, 1), (2, 3)) * 2.0
    t1new_bb += einsum(x18, (0, 1), t2.abab, (0, 2, 1, 3), (2, 3))
    x19 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x19 += einsum(v.aaa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 4, 0))
    x20 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x20 += einsum(x0, (0, 1, 2), (0, 1, 2)) * -1.0
    x20 += einsum(x19, (0, 1, 2), (0, 1, 2)) * 2.0
    x20 += einsum(x1, (0, 1, 2), (0, 1, 2))
    x20 += einsum(x5, (0,), t1.aa, (1, 2), (1, 2, 0))
    x21 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x21 += einsum(v.aaa.xov, (0, 1, 2), x20, (3, 2, 0), (1, 3))
    del x20
    x22 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x22 += einsum(x5, (0,), v.aaa.xoo, (0, 1, 2), (1, 2))
    x23 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x23 += einsum(f.aa.ov, (0, 1), (0, 1))
    x23 += einsum(x16, (0, 1), (0, 1)) * -1.0
    del x16
    x24 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x24 += einsum(t1.aa, (0, 1), x23, (2, 1), (0, 2))
    x25 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x25 += einsum(f.aa.oo, (0, 1), (0, 1))
    x25 += einsum(x21, (0, 1), (0, 1))
    del x21
    x25 += einsum(x22, (0, 1), (1, 0))
    x25 += einsum(x24, (0, 1), (1, 0))
    del x24
    t1new_aa += einsum(t1.aa, (0, 1), x25, (0, 2), (2, 1)) * -1.0
    t2new_abab = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    t2new_abab += einsum(x25, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1.0
    del x25
    x26 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x26 += einsum(t1.bb, (0, 1), v.abb.xoo, (2, 3, 0), (3, 1, 2))
    x27 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x27 += einsum(v.aaa.xov, (0, 1, 2), t2.abab, (1, 3, 2, 4), (3, 4, 0))
    x28 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x28 += einsum(t2.bbbb, (0, 1, 2, 3), (0, 1, 2, 3))
    x28 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -0.5
    x29 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x29 += einsum(v.abb.xov, (0, 1, 2), x28, (1, 3, 2, 4), (3, 4, 0))
    del x28
    x30 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x30 += einsum(x26, (0, 1, 2), (0, 1, 2)) * -0.5
    x30 += einsum(x27, (0, 1, 2), (0, 1, 2)) * 0.5
    x30 += einsum(x29, (0, 1, 2), (0, 1, 2))
    x30 += einsum(x5, (0,), t1.bb, (1, 2), (1, 2, 0)) * 0.5
    t1new_bb += einsum(v.abb.xvv, (0, 1, 2), x30, (3, 2, 0), (3, 1)) * 2.0
    del x30
    x31 = np.zeros((nocc[1], nocc[1], naux), dtype=types[float])
    x31 += einsum(v.abb.xoo, (0, 1, 2), (1, 2, 0))
    x31 += einsum(x12, (0, 1, 2), (1, 0, 2))
    x32 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x32 += einsum(v.abb.xov, (0, 1, 2), x31, (3, 4, 0), (4, 1, 3, 2))
    t1new_bb += einsum(t2.bbbb, (0, 1, 2, 3), x32, (4, 0, 1, 3), (4, 2)) * 2.0
    del x32
    x33 = np.zeros((nocc[1], nocc[1], naux), dtype=types[float])
    x33 += einsum(v.abb.xoo, (0, 1, 2), (1, 2, 0))
    x33 += einsum(x12, (0, 1, 2), (0, 1, 2))
    x34 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x34 += einsum(v.aaa.xov, (0, 1, 2), x33, (3, 4, 0), (1, 4, 3, 2))
    t1new_bb += einsum(t2.abab, (0, 1, 2, 3), x34, (0, 1, 4, 2), (4, 3)) * -1.0
    del x34
    x35 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x35 += einsum(v.abb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (3, 4, 0))
    x36 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x36 += einsum(x26, (0, 1, 2), (0, 1, 2)) * -1.0
    x36 += einsum(x27, (0, 1, 2), (0, 1, 2))
    x36 += einsum(x35, (0, 1, 2), (0, 1, 2)) * 2.0
    x36 += einsum(x5, (0,), t1.bb, (1, 2), (1, 2, 0))
    x37 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x37 += einsum(v.abb.xov, (0, 1, 2), x36, (3, 2, 0), (1, 3)) * 0.5
    del x36
    x38 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x38 += einsum(x5, (0,), v.abb.xoo, (0, 1, 2), (1, 2)) * 0.5
    x39 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x39 += einsum(f.bb.ov, (0, 1), (0, 1))
    x39 += einsum(x13, (0, 1), (0, 1)) * -1.0
    del x13
    x40 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x40 += einsum(t1.bb, (0, 1), x39, (2, 1), (0, 2)) * 0.5
    x41 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x41 += einsum(f.bb.oo, (0, 1), (0, 1)) * 0.5
    x41 += einsum(x37, (0, 1), (0, 1))
    del x37
    x41 += einsum(x38, (0, 1), (1, 0))
    del x38
    x41 += einsum(x40, (0, 1), (1, 0))
    del x40
    t1new_bb += einsum(t1.bb, (0, 1), x41, (0, 2), (2, 1)) * -2.0
    t2new_abab += einsum(x41, (0, 1), t2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -2.0
    del x41
    x42 = np.zeros((nvir[0], nvir[0], nvir[0], nvir[0]), dtype=types[float])
    x42 += einsum(v.aaa.xvv, (0, 1, 2), v.aaa.xvv, (0, 3, 4), (1, 3, 4, 2))
    t2new_aaaa = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    t2new_aaaa += einsum(t2.aaaa, (0, 1, 2, 3), x42, (4, 3, 5, 2), (0, 1, 4, 5)) * 2.0
    del x42
    x43 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x43 += einsum(v.aaa.xov, (0, 1, 2), v.aaa.xov, (0, 3, 4), (1, 3, 2, 4))
    x44 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x44 += einsum(t2.aaaa, (0, 1, 2, 3), x43, (4, 5, 2, 3), (0, 1, 5, 4)) * -1.0
    x45 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x45 += einsum(t1.aa, (0, 1), x44, (2, 3, 4, 0), (2, 3, 4, 1))
    t2new_aaaa += einsum(t1.aa, (0, 1), x45, (2, 3, 0, 4), (2, 3, 1, 4)) * 2.0
    del x45
    x46 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x46 += einsum(t1.aa, (0, 1), v.aaa.xvv, (2, 3, 1), (0, 3, 2))
    x47 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x47 += einsum(x46, (0, 1, 2), x46, (3, 4, 2), (0, 3, 1, 4))
    x48 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x48 += einsum(x46, (0, 1, 2), (0, 1, 2))
    x48 += einsum(x19, (0, 1, 2), (0, 1, 2)) * 2.0
    x48 += einsum(x1, (0, 1, 2), (0, 1, 2))
    x49 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x49 += einsum(v.aaa.xov, (0, 1, 2), x48, (1, 3, 0), (2, 3))
    del x48
    x50 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x50 += einsum(x5, (0,), v.aaa.xvv, (0, 1, 2), (1, 2))
    x51 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x51 += einsum(x49, (0, 1), (0, 1))
    del x49
    x51 += einsum(x50, (0, 1), (1, 0)) * -1.0
    x52 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x52 += einsum(x51, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -2.0
    del x51
    x53 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x53 += einsum(x43, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x53 += einsum(x43, (0, 1, 2, 3), (1, 0, 3, 2))
    x54 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x54 += einsum(t2.aaaa, (0, 1, 2, 3), x53, (1, 4, 5, 3), (0, 4, 2, 5))
    del x53
    x55 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x55 += einsum(t2.aaaa, (0, 1, 2, 3), x54, (4, 1, 5, 3), (0, 4, 2, 5)) * -4.0
    del x54
    x56 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x56 += einsum(v.abb.xov, (0, 1, 2), v.abb.xov, (0, 3, 4), (1, 3, 2, 4))
    x57 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x57 += einsum(x56, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x57 += einsum(x56, (0, 1, 2, 3), (1, 0, 3, 2))
    x58 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x58 += einsum(t2.abab, (0, 1, 2, 3), x57, (1, 4, 5, 3), (0, 4, 2, 5))
    del x57
    x59 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x59 += einsum(t2.abab, (0, 1, 2, 3), x58, (4, 1, 5, 3), (0, 4, 2, 5)) * -1.0
    del x58
    x60 = np.zeros((nocc[0], nvir[0], nvir[0], nvir[0]), dtype=types[float])
    x60 += einsum(v.aaa.xov, (0, 1, 2), v.aaa.xvv, (0, 3, 4), (1, 2, 3, 4))
    x61 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x61 += einsum(t2.aaaa, (0, 1, 2, 3), x60, (4, 2, 5, 3), (0, 1, 4, 5))
    del x60
    x62 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x62 += einsum(x18, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4)) * -1.0
    x63 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x63 += einsum(v.aaa.xoo, (0, 1, 2), v.aaa.xoo, (0, 3, 4), (1, 3, 4, 2))
    x64 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x64 += einsum(x7, (0, 1, 2), x7, (3, 4, 2), (0, 3, 1, 4))
    x65 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x65 += einsum(x63, (0, 1, 2, 3), (3, 2, 1, 0))
    x65 += einsum(x64, (0, 1, 2, 3), (2, 3, 1, 0))
    x66 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x66 += einsum(t1.aa, (0, 1), x65, (0, 2, 3, 4), (2, 3, 4, 1)) * 0.5
    del x65
    x67 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x67 += einsum(x61, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    del x61
    x67 += einsum(x62, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    del x62
    x67 += einsum(x66, (0, 1, 2, 3), (0, 2, 1, 3))
    del x66
    x68 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x68 += einsum(t1.aa, (0, 1), x67, (0, 2, 3, 4), (2, 3, 1, 4)) * 2.0
    del x67
    x69 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x69 += einsum(x47, (0, 1, 2, 3), (0, 1, 2, 3))
    del x47
    x69 += einsum(x52, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x52
    x69 += einsum(x55, (0, 1, 2, 3), (1, 0, 3, 2))
    del x55
    x69 += einsum(x59, (0, 1, 2, 3), (0, 1, 2, 3))
    del x59
    x69 += einsum(x68, (0, 1, 2, 3), (1, 0, 2, 3))
    del x68
    t2new_aaaa += einsum(x69, (0, 1, 2, 3), (0, 1, 2, 3))
    t2new_aaaa += einsum(x69, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x69
    x70 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x70 += einsum(v.aaa.xov, (0, 1, 2), x1, (3, 4, 0), (3, 1, 4, 2))
    x71 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x71 += einsum(v.aaa.xvv, (0, 1, 2), x7, (3, 4, 0), (3, 4, 1, 2))
    x72 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x72 += einsum(t2.aaaa, (0, 1, 2, 3), x71, (4, 1, 5, 3), (4, 0, 2, 5))
    del x71
    x73 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x73 += einsum(v.aaa.xov, (0, 1, 2), (1, 2, 0)) * 0.5
    x73 += einsum(x0, (0, 1, 2), (0, 1, 2)) * -0.5
    x73 += einsum(x19, (0, 1, 2), (0, 1, 2))
    x73 += einsum(x1, (0, 1, 2), (0, 1, 2)) * 0.5
    x74 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x74 += einsum(x46, (0, 1, 2), x73, (3, 4, 2), (0, 3, 1, 4)) * 2.0
    del x73
    x75 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x75 += einsum(v.aaa.xoo, (0, 1, 2), v.aaa.xvv, (0, 3, 4), (1, 2, 3, 4))
    x76 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x76 += einsum(v.aaa.xov, (0, 1, 2), (1, 2, 0))
    x76 += einsum(x1, (0, 1, 2), (0, 1, 2))
    x77 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x77 += einsum(v.aaa.xov, (0, 1, 2), x76, (3, 4, 0), (1, 3, 2, 4))
    del x76
    x78 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x78 += einsum(x75, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x75
    x78 += einsum(x77, (0, 1, 2, 3), (0, 1, 2, 3))
    del x77
    x79 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x79 += einsum(t2.aaaa, (0, 1, 2, 3), x78, (1, 4, 3, 5), (0, 4, 2, 5)) * 2.0
    del x78
    x80 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x80 += einsum(v.aaa.xoo, (0, 1, 2), x7, (3, 4, 0), (3, 1, 2, 4))
    x81 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x81 += einsum(t1.aa, (0, 1), x80, (2, 3, 4, 0), (2, 3, 4, 1))
    x82 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x82 += einsum(v.aaa.xoo, (0, 1, 2), v.abb.xov, (0, 3, 4), (1, 2, 3, 4))
    x83 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x83 += einsum(t2.abab, (0, 1, 2, 3), x82, (4, 5, 1, 3), (0, 5, 4, 2))
    del x82
    x84 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x84 += einsum(x46, (0, 1, 2), x7, (3, 4, 2), (3, 0, 4, 1))
    x85 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x85 += einsum(v.abb.xov, (0, 1, 2), x7, (3, 4, 0), (3, 4, 1, 2))
    x86 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x86 += einsum(t2.abab, (0, 1, 2, 3), x85, (4, 5, 1, 3), (4, 0, 5, 2))
    del x85
    x87 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x87 += einsum(v.aaa.xoo, (0, 1, 2), v.aaa.xov, (0, 3, 4), (1, 2, 3, 4))
    x88 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x88 += einsum(x87, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x88 += einsum(x87, (0, 1, 2, 3), (2, 1, 0, 3))
    del x87
    x89 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x89 += einsum(t2.aaaa, (0, 1, 2, 3), x88, (1, 4, 5, 3), (0, 4, 5, 2)) * 2.0
    del x88
    x90 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x90 += einsum(v.aaa.xov, (0, 1, 2), x7, (3, 4, 0), (3, 1, 4, 2))
    del x7
    x91 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x91 += einsum(x90, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x91 += einsum(x90, (0, 1, 2, 3), (0, 2, 1, 3))
    del x90
    x92 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x92 += einsum(t2.aaaa, (0, 1, 2, 3), x91, (4, 1, 5, 3), (0, 4, 5, 2)) * 2.0
    del x91
    x93 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x93 += einsum(x81, (0, 1, 2, 3), (0, 2, 1, 3))
    del x81
    x93 += einsum(x83, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    del x83
    x93 += einsum(x84, (0, 1, 2, 3), (0, 1, 2, 3))
    del x84
    x93 += einsum(x86, (0, 1, 2, 3), (0, 1, 2, 3))
    del x86
    x93 += einsum(x89, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x89
    x93 += einsum(x92, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x92
    x93 += einsum(x11, (0, 1, 2, 3), (2, 0, 1, 3))
    del x11
    x94 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x94 += einsum(t1.aa, (0, 1), x93, (2, 3, 0, 4), (2, 3, 1, 4))
    del x93
    x95 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x95 += einsum(x70, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x70
    x95 += einsum(x72, (0, 1, 2, 3), (0, 1, 2, 3)) * -2.0
    del x72
    x95 += einsum(x74, (0, 1, 2, 3), (0, 1, 3, 2))
    del x74
    x95 += einsum(x79, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x79
    x95 += einsum(x94, (0, 1, 2, 3), (0, 1, 2, 3))
    del x94
    t2new_aaaa += einsum(x95, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    t2new_aaaa += einsum(x95, (0, 1, 2, 3), (0, 1, 3, 2))
    t2new_aaaa += einsum(x95, (0, 1, 2, 3), (1, 0, 2, 3))
    t2new_aaaa += einsum(x95, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x95
    x96 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x96 += einsum(t2.aaaa, (0, 1, 2, 3), x80, (4, 0, 5, 1), (4, 5, 2, 3))
    del x80
    x97 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x97 += einsum(t1.aa, (0, 1), x18, (2, 1), (0, 2))
    del x18
    x98 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x98 += einsum(f.aa.oo, (0, 1), (0, 1))
    x98 += einsum(x97, (0, 1), (0, 1))
    del x97
    x99 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x99 += einsum(x98, (0, 1), t2.aaaa, (2, 1, 3, 4), (2, 0, 3, 4)) * -2.0
    del x98
    x100 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x100 += einsum(x0, (0, 1, 2), (0, 1, 2)) * -1.0
    del x0
    x100 += einsum(x19, (0, 1, 2), (0, 1, 2)) * 2.0
    x100 += einsum(x1, (0, 1, 2), (0, 1, 2))
    x101 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x101 += einsum(v.aaa.xov, (0, 1, 2), x100, (3, 2, 0), (1, 3))
    del x100
    x102 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x102 += einsum(x101, (0, 1), (0, 1))
    del x101
    x102 += einsum(x22, (0, 1), (1, 0))
    del x22
    x103 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x103 += einsum(x102, (0, 1), t2.aaaa, (2, 0, 3, 4), (2, 1, 3, 4)) * -2.0
    del x102
    x104 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x104 += einsum(x96, (0, 1, 2, 3), (0, 1, 3, 2)) * -2.0
    del x96
    x104 += einsum(x99, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x99
    x104 += einsum(x103, (0, 1, 2, 3), (0, 1, 3, 2))
    del x103
    t2new_aaaa += einsum(x104, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    t2new_aaaa += einsum(x104, (0, 1, 2, 3), (1, 0, 2, 3))
    del x104
    x105 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x105 += einsum(f.aa.vv, (0, 1), t2.aaaa, (2, 3, 4, 1), (2, 3, 0, 4))
    x106 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x106 += einsum(x105, (0, 1, 2, 3), (1, 0, 2, 3)) * -2.0
    del x105
    x106 += einsum(x43, (0, 1, 2, 3), (1, 0, 2, 3))
    t2new_aaaa += einsum(x106, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    t2new_aaaa += einsum(x106, (0, 1, 2, 3), (0, 1, 3, 2))
    del x106
    x107 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x107 += einsum(x63, (0, 1, 2, 3), (3, 2, 1, 0))
    del x63
    x107 += einsum(x44, (0, 1, 2, 3), (2, 1, 3, 0))
    del x44
    x107 += einsum(x64, (0, 1, 2, 3), (2, 1, 3, 0))
    del x64
    t2new_aaaa += einsum(t2.aaaa, (0, 1, 2, 3), x107, (0, 4, 1, 5), (4, 5, 2, 3)) * -2.0
    del x107
    x108 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x108 += einsum(v.aaa.xov, (0, 1, 2), (1, 2, 0))
    x108 += einsum(x46, (0, 1, 2), (0, 1, 2))
    x108 += einsum(x19, (0, 1, 2), (0, 1, 2)) * 2.0
    x108 += einsum(x1, (0, 1, 2), (0, 1, 2))
    x109 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x109 += einsum(t1.bb, (0, 1), v.abb.xvv, (2, 3, 1), (0, 3, 2))
    x110 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x110 += einsum(v.abb.xov, (0, 1, 2), (1, 2, 0))
    x110 += einsum(x109, (0, 1, 2), (0, 1, 2))
    x110 += einsum(x27, (0, 1, 2), (0, 1, 2))
    x110 += einsum(x35, (0, 1, 2), (0, 1, 2)) * 2.0
    t2new_abab += einsum(x108, (0, 1, 2), x110, (3, 4, 2), (0, 3, 1, 4))
    del x108, x110
    x111 = np.zeros((nvir[0], nvir[0], naux), dtype=types[float])
    x111 += einsum(t1.aa, (0, 1), v.aaa.xov, (2, 0, 3), (1, 3, 2))
    x112 = np.zeros((nvir[0], nvir[0], naux), dtype=types[float])
    x112 += einsum(v.aaa.xvv, (0, 1, 2), (1, 2, 0))
    x112 += einsum(x111, (0, 1, 2), (0, 1, 2)) * -1.0
    del x111
    x113 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x113 += einsum(v.aaa.xov, (0, 1, 2), x8, (3, 4, 0), (4, 3, 1, 2))
    x114 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x114 += einsum(t2.aaaa, (0, 1, 2, 3), x43, (1, 4, 5, 3), (4, 0, 5, 2))
    x114 += einsum(x112, (0, 1, 2), x8, (3, 4, 2), (4, 3, 1, 0)) * 0.5
    x114 += einsum(t1.aa, (0, 1), x113, (0, 2, 3, 4), (3, 2, 4, 1)) * 0.5
    del x113
    t2new_abab += einsum(t2.abab, (0, 1, 2, 3), x114, (0, 4, 2, 5), (4, 1, 5, 3)) * -2.0
    del x114
    x115 = np.zeros((nvir[1], nvir[1], naux), dtype=types[float])
    x115 += einsum(t1.bb, (0, 1), v.abb.xov, (2, 0, 3), (1, 3, 2))
    x116 = np.zeros((nvir[1], nvir[1], naux), dtype=types[float])
    x116 += einsum(v.abb.xvv, (0, 1, 2), (1, 2, 0))
    x116 += einsum(x115, (0, 1, 2), (0, 1, 2)) * -1.0
    del x115
    x117 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x117 += einsum(v.abb.xov, (0, 1, 2), x33, (3, 4, 0), (4, 3, 1, 2))
    x118 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x118 += einsum(t2.bbbb, (0, 1, 2, 3), x56, (1, 4, 5, 3), (4, 0, 5, 2)) * 2.0
    x118 += einsum(x116, (0, 1, 2), x33, (3, 4, 2), (4, 3, 1, 0))
    x118 += einsum(t1.bb, (0, 1), x117, (0, 2, 3, 4), (3, 2, 4, 1))
    del x117
    t2new_abab += einsum(t2.abab, (0, 1, 2, 3), x118, (1, 4, 3, 5), (0, 4, 2, 5)) * -1.0
    del x118
    x119 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x119 += einsum(v.aaa.xov, (0, 1, 2), v.abb.xov, (0, 3, 4), (1, 3, 2, 4))
    x120 = np.zeros((nocc[1], nocc[1], nvir[0], nvir[0]), dtype=types[float])
    x120 += einsum(t2.abab, (0, 1, 2, 3), x119, (0, 4, 5, 3), (4, 1, 5, 2))
    x120 += einsum(x112, (0, 1, 2), x33, (3, 4, 2), (4, 3, 1, 0)) * -1.0
    del x112
    t2new_abab += einsum(t2.abab, (0, 1, 2, 3), x120, (1, 4, 2, 5), (0, 4, 5, 3))
    del x120
    x121 = np.zeros((nocc[0], nocc[0], nvir[1], nvir[1]), dtype=types[float])
    x121 += einsum(x116, (0, 1, 2), x8, (3, 4, 2), (4, 3, 1, 0))
    t2new_abab += einsum(t2.abab, (0, 1, 2, 3), x121, (0, 4, 3, 5), (4, 1, 2, 5)) * -1.0
    del x121
    x122 = np.zeros((nocc[0], nvir[0], nvir[1], nvir[1]), dtype=types[float])
    x122 += einsum(v.aaa.xov, (0, 1, 2), v.abb.xvv, (0, 3, 4), (1, 2, 3, 4))
    x123 = np.zeros((nvir[0], nvir[0], nvir[1], nvir[1]), dtype=types[float])
    x123 += einsum(t1.aa, (0, 1), x122, (0, 2, 3, 4), (2, 1, 4, 3))
    del x122
    x123 += einsum(v.aaa.xvv, (0, 1, 2), x116, (3, 4, 0), (1, 2, 4, 3)) * -1.0
    del x116
    t2new_abab += einsum(t2.abab, (0, 1, 2, 3), x123, (2, 4, 3, 5), (0, 1, 4, 5)) * -1.0
    del x123
    x124 = np.zeros((nocc[0], nocc[0], nocc[1], nocc[1]), dtype=types[float])
    x124 += einsum(t2.abab, (0, 1, 2, 3), x119, (4, 5, 2, 3), (4, 0, 5, 1))
    del x119
    x124 += einsum(x33, (0, 1, 2), x8, (3, 4, 2), (4, 3, 1, 0))
    x125 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x125 += einsum(t2.abab, (0, 1, 2, 3), (0, 1, 2, 3))
    x125 += einsum(t1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    t2new_abab += einsum(x124, (0, 1, 2, 3), x125, (0, 2, 4, 5), (1, 3, 4, 5))
    del x124, x125
    x126 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x126 += einsum(x109, (0, 1, 2), (0, 1, 2))
    x126 += einsum(x27, (0, 1, 2), (0, 1, 2))
    x126 += einsum(x35, (0, 1, 2), (0, 1, 2)) * 2.0
    x126 += einsum(x5, (0,), t1.bb, (1, 2), (1, 2, 0))
    x127 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x127 += einsum(x5, (0,), v.abb.xvv, (0, 1, 2), (1, 2))
    x128 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x128 += einsum(f.bb.vv, (0, 1), (0, 1)) * -1.0
    x128 += einsum(v.abb.xov, (0, 1, 2), x126, (1, 3, 0), (2, 3))
    del x126
    x128 += einsum(x127, (0, 1), (1, 0)) * -1.0
    x128 += einsum(t1.bb, (0, 1), x39, (0, 2), (2, 1))
    del x39
    t2new_abab += einsum(x128, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -1.0
    del x128
    x129 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x129 += einsum(x46, (0, 1, 2), (0, 1, 2))
    x129 += einsum(x19, (0, 1, 2), (0, 1, 2)) * 2.0
    del x19
    x129 += einsum(x1, (0, 1, 2), (0, 1, 2))
    del x1
    x129 += einsum(x5, (0,), t1.aa, (1, 2), (1, 2, 0))
    x130 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x130 += einsum(f.aa.vv, (0, 1), (0, 1)) * -1.0
    x130 += einsum(v.aaa.xov, (0, 1, 2), x129, (1, 3, 0), (2, 3))
    del x129
    x130 += einsum(x50, (0, 1), (1, 0)) * -1.0
    del x50
    x130 += einsum(t1.aa, (0, 1), x23, (0, 2), (2, 1))
    del x23
    t2new_abab += einsum(x130, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1.0
    del x130
    x131 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x131 += einsum(v.abb.xov, (0, 1, 2), (1, 2, 0))
    x131 += einsum(x109, (0, 1, 2), (0, 1, 2))
    x132 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x132 += einsum(v.abb.xov, (0, 1, 2), x10, (3, 4, 0), (4, 3, 1, 2))
    del x10
    x133 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x133 += einsum(x131, (0, 1, 2), x8, (3, 4, 2), (4, 3, 0, 1))
    del x8, x131
    x133 += einsum(t2.bbbb, (0, 1, 2, 3), x132, (4, 5, 1, 3), (5, 4, 0, 2)) * 2.0
    del x132
    t2new_abab += einsum(t1.aa, (0, 1), x133, (0, 2, 3, 4), (2, 3, 1, 4)) * -1.0
    del x133
    x134 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x134 += einsum(v.aaa.xov, (0, 1, 2), (1, 2, 0))
    x134 += einsum(x46, (0, 1, 2), (0, 1, 2))
    del x46
    x135 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x135 += einsum(v.aaa.xov, (0, 1, 2), x31, (3, 4, 0), (1, 4, 3, 2))
    del x31
    x136 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x136 += einsum(x134, (0, 1, 2), x33, (3, 4, 2), (0, 4, 3, 1))
    del x33, x134
    x136 += einsum(t2.aaaa, (0, 1, 2, 3), x135, (1, 4, 5, 3), (0, 5, 4, 2)) * 2.0
    del x135
    t2new_abab += einsum(t1.bb, (0, 1), x136, (2, 0, 3, 4), (2, 3, 4, 1)) * -1.0
    del x136
    x137 = np.zeros((nvir[1], nvir[1], nvir[1], nvir[1]), dtype=types[float])
    x137 += einsum(v.abb.xvv, (0, 1, 2), v.abb.xvv, (0, 3, 4), (1, 3, 4, 2))
    t2new_bbbb = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    t2new_bbbb += einsum(t2.bbbb, (0, 1, 2, 3), x137, (4, 2, 5, 3), (0, 1, 4, 5)) * -2.0
    del x137
    x138 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x138 += einsum(t2.bbbb, (0, 1, 2, 3), x56, (4, 5, 2, 3), (0, 1, 5, 4)) * -1.0
    x139 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x139 += einsum(t1.bb, (0, 1), x138, (2, 3, 4, 0), (2, 3, 4, 1))
    t2new_bbbb += einsum(t1.bb, (0, 1), x139, (2, 3, 0, 4), (2, 3, 1, 4)) * 2.0
    del x139
    x140 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x140 += einsum(x109, (0, 1, 2), x109, (3, 4, 2), (0, 3, 1, 4))
    x141 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x141 += einsum(x109, (0, 1, 2), (0, 1, 2))
    x141 += einsum(x27, (0, 1, 2), (0, 1, 2))
    x141 += einsum(x35, (0, 1, 2), (0, 1, 2)) * 2.0
    x142 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x142 += einsum(v.abb.xov, (0, 1, 2), x141, (1, 3, 0), (3, 2))
    del x141
    x143 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x143 += einsum(x142, (0, 1), (1, 0))
    del x142
    x143 += einsum(x127, (0, 1), (1, 0)) * -1.0
    del x127
    x144 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x144 += einsum(x143, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 1, 4)) * -2.0
    del x143
    x145 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x145 += einsum(x56, (0, 1, 2, 3), (1, 0, 2, 3))
    x145 += einsum(x56, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    x146 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x146 += einsum(t2.bbbb, (0, 1, 2, 3), x145, (1, 4, 3, 5), (4, 0, 5, 2))
    del x145
    x147 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x147 += einsum(t2.bbbb, (0, 1, 2, 3), x146, (1, 4, 3, 5), (4, 0, 5, 2)) * -4.0
    del x146
    x148 = np.zeros((nocc[1], nvir[1], nvir[1], nvir[1]), dtype=types[float])
    x148 += einsum(v.abb.xov, (0, 1, 2), v.abb.xvv, (0, 3, 4), (1, 2, 3, 4))
    x149 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x149 += einsum(t2.bbbb, (0, 1, 2, 3), x148, (4, 2, 5, 3), (0, 1, 4, 5))
    del x148
    x150 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x150 += einsum(x15, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4)) * -1.0
    x151 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x151 += einsum(v.abb.xoo, (0, 1, 2), v.abb.xoo, (0, 3, 4), (1, 3, 4, 2))
    x152 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x152 += einsum(x12, (0, 1, 2), x12, (3, 4, 2), (0, 3, 1, 4))
    x153 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x153 += einsum(x151, (0, 1, 2, 3), (3, 2, 1, 0))
    x153 += einsum(x152, (0, 1, 2, 3), (2, 3, 1, 0))
    x154 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x154 += einsum(t1.bb, (0, 1), x153, (0, 2, 3, 4), (2, 3, 4, 1)) * 0.5
    del x153
    x155 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x155 += einsum(x149, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    del x149
    x155 += einsum(x150, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    del x150
    x155 += einsum(x154, (0, 1, 2, 3), (0, 2, 1, 3))
    del x154
    x156 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x156 += einsum(t1.bb, (0, 1), x155, (0, 2, 3, 4), (2, 3, 4, 1)) * 2.0
    del x155
    x157 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x157 += einsum(x140, (0, 1, 2, 3), (0, 1, 2, 3))
    del x140
    x157 += einsum(x144, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x144
    x157 += einsum(x147, (0, 1, 2, 3), (1, 0, 3, 2))
    del x147
    x157 += einsum(x156, (0, 1, 2, 3), (1, 0, 3, 2))
    del x156
    t2new_bbbb += einsum(x157, (0, 1, 2, 3), (0, 1, 2, 3))
    t2new_bbbb += einsum(x157, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x157
    x158 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x158 += einsum(f.bb.vv, (0, 1), t2.bbbb, (2, 3, 4, 1), (2, 3, 0, 4))
    x159 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x159 += einsum(x43, (0, 1, 2, 3), (1, 0, 2, 3))
    x159 += einsum(x43, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x43
    x160 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x160 += einsum(t2.abab, (0, 1, 2, 3), x159, (0, 4, 2, 5), (4, 1, 5, 3))
    del x159
    x161 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x161 += einsum(t2.abab, (0, 1, 2, 3), x160, (0, 4, 2, 5), (4, 1, 5, 3)) * -1.0
    del x160
    x162 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x162 += einsum(x158, (0, 1, 2, 3), (1, 0, 2, 3)) * -2.0
    del x158
    x162 += einsum(x56, (0, 1, 2, 3), (1, 0, 2, 3))
    del x56
    x162 += einsum(x161, (0, 1, 2, 3), (0, 1, 3, 2))
    del x161
    t2new_bbbb += einsum(x162, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    t2new_bbbb += einsum(x162, (0, 1, 2, 3), (0, 1, 3, 2))
    del x162
    x163 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x163 += einsum(v.abb.xoo, (0, 1, 2), x12, (3, 4, 0), (3, 1, 2, 4))
    x164 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x164 += einsum(t2.bbbb, (0, 1, 2, 3), x163, (4, 0, 5, 1), (4, 5, 2, 3))
    x165 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x165 += einsum(t1.bb, (0, 1), x15, (2, 1), (0, 2))
    del x15
    x166 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x166 += einsum(f.bb.oo, (0, 1), (0, 1))
    x166 += einsum(x165, (0, 1), (0, 1))
    del x165
    x167 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x167 += einsum(x166, (0, 1), t2.bbbb, (2, 1, 3, 4), (0, 2, 3, 4)) * -2.0
    del x166
    x168 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x168 += einsum(x26, (0, 1, 2), (0, 1, 2)) * -1.0
    x168 += einsum(x27, (0, 1, 2), (0, 1, 2))
    x168 += einsum(x35, (0, 1, 2), (0, 1, 2)) * 2.0
    x169 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x169 += einsum(v.abb.xov, (0, 1, 2), x168, (3, 2, 0), (3, 1))
    del x168
    x170 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x170 += einsum(x5, (0,), v.abb.xoo, (0, 1, 2), (1, 2))
    del x5
    x171 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x171 += einsum(x169, (0, 1), (1, 0))
    del x169
    x171 += einsum(x170, (0, 1), (1, 0))
    del x170
    x172 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x172 += einsum(x171, (0, 1), t2.bbbb, (2, 0, 3, 4), (1, 2, 3, 4)) * -2.0
    del x171
    x173 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x173 += einsum(x164, (0, 1, 2, 3), (0, 1, 3, 2)) * -2.0
    del x164
    x173 += einsum(x167, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x167
    x173 += einsum(x172, (0, 1, 2, 3), (1, 0, 3, 2))
    del x172
    t2new_bbbb += einsum(x173, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    t2new_bbbb += einsum(x173, (0, 1, 2, 3), (1, 0, 2, 3))
    del x173
    x174 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x174 += einsum(v.abb.xoo, (0, 1, 2), v.abb.xvv, (0, 3, 4), (1, 2, 3, 4))
    x175 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x175 += einsum(t2.bbbb, (0, 1, 2, 3), x174, (4, 1, 5, 3), (0, 4, 2, 5))
    del x174
    x176 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x176 += einsum(v.abb.xvv, (0, 1, 2), x12, (3, 4, 0), (3, 4, 1, 2))
    x177 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x177 += einsum(t2.bbbb, (0, 1, 2, 3), x176, (4, 1, 5, 3), (4, 0, 2, 5))
    del x176
    x178 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x178 += einsum(x27, (0, 1, 2), x35, (3, 4, 2), (0, 3, 1, 4))
    x179 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x179 += einsum(v.abb.xov, (0, 1, 2), (1, 2, 0))
    x179 += einsum(x26, (0, 1, 2), (0, 1, 2)) * -1.0
    x179 += einsum(x27, (0, 1, 2), (0, 1, 2))
    x179 += einsum(x35, (0, 1, 2), (0, 1, 2)) * 2.0
    del x35
    x180 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x180 += einsum(x109, (0, 1, 2), x179, (3, 4, 2), (3, 0, 4, 1))
    del x179
    x181 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x181 += einsum(x26, (0, 1, 2), (0, 1, 2)) * -0.5
    del x26
    x181 += einsum(x27, (0, 1, 2), (0, 1, 2)) * 0.5
    del x27
    x181 += einsum(x29, (0, 1, 2), (0, 1, 2))
    del x29
    x182 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x182 += einsum(v.abb.xov, (0, 1, 2), x181, (3, 4, 0), (3, 1, 4, 2)) * 2.0
    del x181
    x183 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x183 += einsum(v.abb.xoo, (0, 1, 2), v.aaa.xov, (0, 3, 4), (3, 1, 2, 4))
    x184 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x184 += einsum(t2.abab, (0, 1, 2, 3), x183, (0, 4, 5, 2), (1, 5, 4, 3))
    del x183
    x185 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x185 += einsum(t1.bb, (0, 1), x163, (2, 3, 4, 0), (2, 3, 4, 1))
    del x163
    x186 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x186 += einsum(x109, (0, 1, 2), x12, (3, 4, 2), (3, 0, 4, 1))
    del x109
    x187 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x187 += einsum(v.aaa.xov, (0, 1, 2), x12, (3, 4, 0), (1, 3, 4, 2))
    x188 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x188 += einsum(t2.abab, (0, 1, 2, 3), x187, (0, 4, 5, 2), (4, 1, 5, 3))
    del x187
    x189 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x189 += einsum(v.abb.xoo, (0, 1, 2), v.abb.xov, (0, 3, 4), (1, 2, 3, 4))
    x190 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x190 += einsum(x189, (0, 1, 2, 3), (1, 0, 2, 3))
    x190 += einsum(x189, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    del x189
    x191 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x191 += einsum(t2.bbbb, (0, 1, 2, 3), x190, (4, 5, 1, 3), (4, 5, 0, 2)) * 2.0
    del x190
    x192 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x192 += einsum(v.abb.xov, (0, 1, 2), x12, (3, 4, 0), (3, 1, 4, 2))
    del x12
    x193 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x193 += einsum(x192, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x193 += einsum(x192, (0, 1, 2, 3), (0, 2, 1, 3))
    del x192
    x194 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x194 += einsum(t2.bbbb, (0, 1, 2, 3), x193, (4, 1, 5, 3), (4, 5, 0, 2)) * 2.0
    del x193
    x195 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x195 += einsum(x184, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    del x184
    x195 += einsum(x185, (0, 1, 2, 3), (0, 2, 1, 3))
    del x185
    x195 += einsum(x186, (0, 1, 2, 3), (0, 2, 1, 3))
    del x186
    x195 += einsum(x188, (0, 1, 2, 3), (0, 2, 1, 3))
    del x188
    x195 += einsum(x191, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    del x191
    x195 += einsum(x194, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x194
    x196 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x196 += einsum(t1.bb, (0, 1), x195, (2, 0, 3, 4), (2, 3, 4, 1))
    del x195
    x197 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x197 += einsum(x175, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x175
    x197 += einsum(x177, (0, 1, 2, 3), (0, 1, 2, 3)) * -2.0
    del x177
    x197 += einsum(x178, (0, 1, 2, 3), (0, 1, 2, 3)) * -2.0
    del x178
    x197 += einsum(x180, (0, 1, 2, 3), (1, 0, 2, 3))
    del x180
    x197 += einsum(x182, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x182
    x197 += einsum(x196, (0, 1, 2, 3), (0, 1, 3, 2))
    del x196
    t2new_bbbb += einsum(x197, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    t2new_bbbb += einsum(x197, (0, 1, 2, 3), (0, 1, 3, 2))
    t2new_bbbb += einsum(x197, (0, 1, 2, 3), (1, 0, 2, 3))
    t2new_bbbb += einsum(x197, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x197
    x198 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x198 += einsum(x151, (0, 1, 2, 3), (3, 2, 1, 0))
    del x151
    x198 += einsum(x138, (0, 1, 2, 3), (2, 1, 3, 0))
    del x138
    x198 += einsum(x152, (0, 1, 2, 3), (2, 1, 3, 0))
    del x152
    t2new_bbbb += einsum(t2.bbbb, (0, 1, 2, 3), x198, (0, 4, 1, 5), (4, 5, 2, 3)) * -2.0
    del x198

    t1new.aa = t1new_aa
    t1new.bb = t1new_bb
    t2new.aaaa = t2new_aaaa
    t2new.abab = t2new_abab
    t2new.bbbb = t2new_bbbb

    return {"t1new": t1new, "t2new": t2new}

def update_lams(f=None, v=None, nocc=None, nvir=None, naux=None, t1=None, t2=None, l1=None, l2=None, **kwargs):
    l1new = Namespace()
    l2new = Namespace()

    # L amplitudes
    l1new_aa = np.zeros((nvir[0], nocc[0]), dtype=types[float])
    l1new_aa += einsum(f.aa.ov, (0, 1), (1, 0))
    l1new_bb = np.zeros((nvir[1], nocc[1]), dtype=types[float])
    l1new_bb += einsum(f.bb.ov, (0, 1), (1, 0))
    x0 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x0 += einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    x1 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x1 += einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    x2 = np.zeros((nocc[0], nocc[0], naux), dtype=types[float])
    x2 += einsum(t1.aa, (0, 1), v.aaa.xov, (2, 3, 1), (0, 3, 2))
    x3 = np.zeros((nocc[1], nocc[1], naux), dtype=types[float])
    x3 += einsum(t1.bb, (0, 1), v.abb.xov, (2, 3, 1), (0, 3, 2))
    x4 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x4 += einsum(t1.aa, (0, 1), v.aaa.xvv, (2, 3, 1), (0, 3, 2))
    x5 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x5 += einsum(v.aaa.xov, (0, 1, 2), t2.aaaa, (3, 1, 4, 2), (3, 4, 0))
    x6 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x6 += einsum(v.abb.xov, (0, 1, 2), t2.abab, (3, 1, 4, 2), (3, 4, 0))
    x7 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x7 += einsum(v.aaa.xov, (0, 1, 2), (1, 2, 0))
    x7 += einsum(x4, (0, 1, 2), (0, 1, 2))
    x7 += einsum(x5, (0, 1, 2), (0, 1, 2)) * 2.0
    x7 += einsum(x6, (0, 1, 2), (0, 1, 2))
    x8 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x8 += einsum(x7, (0, 1, 2), l2.aaaa, (3, 1, 4, 0), (4, 3, 2)) * 0.5
    x9 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x9 += einsum(t1.bb, (0, 1), v.abb.xvv, (2, 3, 1), (0, 3, 2))
    x10 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x10 += einsum(v.aaa.xov, (0, 1, 2), t2.abab, (1, 3, 2, 4), (3, 4, 0))
    x11 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x11 += einsum(v.abb.xov, (0, 1, 2), t2.bbbb, (3, 1, 4, 2), (3, 4, 0))
    x12 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x12 += einsum(v.abb.xov, (0, 1, 2), (1, 2, 0))
    x12 += einsum(x9, (0, 1, 2), (0, 1, 2))
    x12 += einsum(x10, (0, 1, 2), (0, 1, 2))
    x12 += einsum(x11, (0, 1, 2), (0, 1, 2)) * 2.0
    x13 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x13 += einsum(x12, (0, 1, 2), l2.abab, (3, 1, 4, 0), (4, 3, 2)) * 0.25
    x14 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x14 += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    x15 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x15 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    x16 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x16 += einsum(x14, (0, 1), (0, 1))
    x16 += einsum(x15, (0, 1), (0, 1)) * 0.5
    x17 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x17 += einsum(x16, (0, 1), v.aaa.xov, (2, 3, 1), (3, 0, 2)) * 0.5
    x18 = np.zeros((nocc[0], nocc[0], naux), dtype=types[float])
    x18 += einsum(v.aaa.xoo, (0, 1, 2), (1, 2, 0))
    x18 += einsum(x2, (0, 1, 2), (0, 1, 2))
    x19 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x19 += einsum(v.aaa.xoo, (0, 1, 2), x0, (1, 3, 2, 4), (3, 4, 0)) * 0.5
    x19 += einsum(v.abb.xoo, (0, 1, 2), x1, (3, 1, 2, 4), (3, 4, 0)) * -0.25
    x19 += einsum(x2, (0, 1, 2), x0, (0, 3, 1, 4), (3, 4, 2)) * 0.5
    x19 += einsum(x3, (0, 1, 2), x1, (3, 0, 1, 4), (3, 4, 2)) * -0.25
    x19 += einsum(x8, (0, 1, 2), (0, 1, 2))
    x19 += einsum(x13, (0, 1, 2), (0, 1, 2))
    x19 += einsum(x17, (0, 1, 2), (0, 1, 2)) * -1.0
    x19 += einsum(l1.aa, (0, 1), x18, (1, 2, 3), (2, 0, 3)) * -0.25
    l1new_aa += einsum(v.aaa.xvv, (0, 1, 2), x19, (3, 2, 0), (1, 3)) * 4.0
    del x19
    x20 = np.zeros((nocc[0], nvir[0], nvir[1], nvir[1]), dtype=types[float])
    x20 += einsum(v.aaa.xov, (0, 1, 2), v.abb.xvv, (0, 3, 4), (1, 2, 3, 4))
    x21 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x21 += einsum(v.aaa.xoo, (0, 1, 2), v.aaa.xov, (0, 3, 4), (1, 2, 3, 4))
    x22 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x22 += einsum(v.aaa.xov, (0, 1, 2), x2, (3, 4, 0), (3, 1, 4, 2))
    x23 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x23 += einsum(x21, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x23 += einsum(x21, (0, 1, 2, 3), (1, 2, 0, 3))
    x23 += einsum(x22, (0, 1, 2, 3), (0, 1, 2, 3))
    x23 += einsum(x22, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    x24 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x24 += einsum(v.abb.xov, (0, 1, 2), (1, 2, 0))
    x24 += einsum(x9, (0, 1, 2), (0, 1, 2))
    x25 = np.zeros((nocc[1], nocc[1], naux), dtype=types[float])
    x25 += einsum(v.abb.xoo, (0, 1, 2), (1, 2, 0))
    x25 += einsum(x3, (0, 1, 2), (0, 1, 2))
    x26 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x26 += einsum(v.aaa.xov, (0, 1, 2), x25, (3, 4, 0), (1, 4, 3, 2))
    x27 = np.zeros((nocc[0], nocc[0], naux), dtype=types[float])
    x27 += einsum(v.aaa.xoo, (0, 1, 2), (1, 2, 0))
    x27 += einsum(x2, (0, 1, 2), (1, 0, 2))
    x28 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x28 += einsum(v.abb.xov, (0, 1, 2), x27, (3, 4, 0), (3, 4, 1, 2))
    l2new_abab = np.zeros((nvir[0], nvir[1], nocc[0], nocc[1]), dtype=types[float])
    l2new_abab += einsum(x1, (0, 1, 2, 3), x28, (4, 0, 2, 5), (3, 5, 4, 1))
    l2new_abab += einsum(l1.aa, (0, 1), x28, (2, 1, 3, 4), (0, 4, 2, 3)) * -1.0
    x29 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x29 += einsum(v.aaa.xov, (0, 1, 2), x2, (1, 3, 0), (3, 2))
    x30 = np.zeros((naux,), dtype=types[float])
    x30 += einsum(t1.aa, (0, 1), v.aaa.xov, (2, 0, 1), (2,))
    x31 = np.zeros((naux,), dtype=types[float])
    x31 += einsum(t1.bb, (0, 1), v.abb.xov, (2, 0, 1), (2,))
    x32 = np.zeros((naux,), dtype=types[float])
    x32 += einsum(x30, (0,), (0,))
    del x30
    x32 += einsum(x31, (0,), (0,))
    del x31
    x33 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x33 += einsum(x32, (0,), v.aaa.xov, (0, 1, 2), (1, 2))
    x34 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x34 += einsum(f.aa.ov, (0, 1), (0, 1))
    x34 += einsum(x29, (0, 1), (0, 1)) * -1.0
    x34 += einsum(x33, (0, 1), (0, 1))
    l2new_abab += einsum(l1.bb, (0, 1), x34, (2, 3), (3, 0, 2, 1))
    x35 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x35 += einsum(v.aaa.xov, (0, 1, 2), v.abb.xov, (0, 3, 4), (1, 3, 2, 4))
    x36 = np.zeros((nocc[0], nocc[0], nocc[1], nocc[1]), dtype=types[float])
    x36 += einsum(t2.abab, (0, 1, 2, 3), x35, (4, 5, 2, 3), (0, 4, 1, 5))
    x37 = np.zeros((nocc[0], nocc[0], nocc[1], nocc[1]), dtype=types[float])
    x37 += einsum(x36, (0, 1, 2, 3), (0, 1, 3, 2))
    x37 += einsum(x25, (0, 1, 2), x27, (3, 4, 2), (4, 3, 1, 0))
    x38 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x38 += einsum(t2.abab, (0, 1, 2, 3), x20, (4, 2, 5, 3), (4, 0, 1, 5))
    x38 += einsum(t2.abab, (0, 1, 2, 3), x23, (4, 5, 0, 2), (5, 4, 1, 3)) * -1.0
    del x23
    x38 += einsum(x18, (0, 1, 2), x24, (3, 4, 2), (1, 0, 3, 4))
    del x24
    x38 += einsum(t2.abab, (0, 1, 2, 3), x26, (4, 1, 5, 2), (4, 0, 5, 3)) * -1.0
    del x26
    x38 += einsum(t2.bbbb, (0, 1, 2, 3), x28, (4, 5, 1, 3), (4, 5, 0, 2)) * 2.0
    x38 += einsum(x34, (0, 1), t2.abab, (2, 3, 1, 4), (0, 2, 3, 4))
    x38 += einsum(t1.bb, (0, 1), x37, (2, 3, 0, 4), (3, 2, 4, 1)) * -1.0
    del x37
    l1new_aa += einsum(l2.abab, (0, 1, 2, 3), x38, (4, 2, 3, 1), (0, 4)) * -1.0
    del x38
    x39 = np.zeros((nocc[0], nvir[0], nvir[0], nvir[0]), dtype=types[float])
    x39 += einsum(v.aaa.xov, (0, 1, 2), v.aaa.xvv, (0, 3, 4), (1, 2, 3, 4))
    x40 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x40 += einsum(x21, (0, 1, 2, 3), (1, 0, 2, 3))
    x40 += einsum(x21, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    x40 += einsum(x22, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x40 += einsum(x22, (0, 1, 2, 3), (0, 2, 1, 3))
    x41 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x41 += einsum(v.aaa.xoo, (0, 1, 2), v.aaa.xoo, (0, 3, 4), (1, 3, 4, 2))
    x42 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x42 += einsum(v.aaa.xov, (0, 1, 2), v.aaa.xov, (0, 3, 4), (1, 3, 2, 4))
    x43 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x43 += einsum(t2.aaaa, (0, 1, 2, 3), x42, (4, 5, 2, 3), (0, 1, 5, 4)) * -1.0
    x44 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x44 += einsum(x2, (0, 1, 2), x2, (3, 4, 2), (0, 3, 1, 4))
    x45 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x45 += einsum(v.aaa.xoo, (0, 1, 2), x2, (3, 4, 0), (3, 1, 2, 4))
    x46 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x46 += einsum(x41, (0, 1, 2, 3), (3, 2, 1, 0))
    x46 += einsum(x43, (0, 1, 2, 3), (2, 3, 1, 0))
    x46 += einsum(x44, (0, 1, 2, 3), (2, 3, 1, 0))
    x46 += einsum(x45, (0, 1, 2, 3), (1, 3, 0, 2))
    x46 += einsum(x45, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    x47 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x47 += einsum(v.aaa.xoo, (0, 1, 2), x4, (3, 4, 0), (1, 2, 3, 4)) * -1.0
    x47 += einsum(t2.aaaa, (0, 1, 2, 3), x39, (4, 2, 3, 5), (4, 0, 1, 5)) * -1.0
    x47 += einsum(x2, (0, 1, 2), x4, (3, 4, 2), (1, 3, 0, 4))
    x47 += einsum(t2.aaaa, (0, 1, 2, 3), x40, (4, 1, 5, 3), (5, 0, 4, 2)) * -2.0
    del x40
    x47 += einsum(t2.abab, (0, 1, 2, 3), x28, (4, 5, 1, 3), (4, 0, 5, 2))
    del x28
    x47 += einsum(v.aaa.xov, (0, 1, 2), x18, (3, 4, 0), (4, 1, 3, 2))
    x47 += einsum(x34, (0, 1), t2.aaaa, (2, 3, 4, 1), (0, 2, 3, 4))
    x47 += einsum(t1.aa, (0, 1), x46, (0, 2, 3, 4), (2, 4, 3, 1)) * -1.0
    del x46
    l1new_aa += einsum(l2.aaaa, (0, 1, 2, 3), x47, (4, 2, 3, 1), (0, 4)) * 2.0
    del x47
    x48 = np.zeros((nocc[0], nocc[0], nvir[1], nvir[1]), dtype=types[float])
    x48 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    x49 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x49 += einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    l2new_abab += einsum(x20, (0, 1, 2, 3), x49, (4, 0, 5, 2), (1, 3, 4, 5)) * -1.0
    del x20
    l2new_abab += einsum(x34, (0, 1), x49, (2, 0, 3, 4), (1, 4, 2, 3)) * -1.0
    x50 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x50 += einsum(t1.aa, (0, 1), x0, (2, 3, 4, 1), (3, 2, 4, 0))
    x51 = np.zeros((nocc[0], nocc[0], nocc[1], nocc[1]), dtype=types[float])
    x51 += einsum(t1.aa, (0, 1), x1, (2, 3, 4, 1), (2, 0, 3, 4))
    x52 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x52 += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 5, 0, 1), (2, 3, 4, 5))
    x53 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x53 += einsum(t2.aaaa, (0, 1, 2, 3), x0, (4, 1, 5, 3), (4, 5, 0, 2)) * -1.0
    x54 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x54 += einsum(t2.abab, (0, 1, 2, 3), x49, (4, 5, 1, 3), (4, 5, 0, 2))
    x55 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x55 += einsum(x53, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x53
    x55 += einsum(x54, (0, 1, 2, 3), (0, 1, 2, 3)) * 0.5
    del x54
    x56 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x56 += einsum(l1.aa, (0, 1), t2.aaaa, (2, 3, 4, 0), (1, 2, 3, 4))
    x56 += einsum(x0, (0, 1, 2, 3), (1, 0, 2, 3))
    x56 += einsum(t1.aa, (0, 1), x52, (2, 0, 3, 4), (2, 3, 4, 1))
    x56 += einsum(x55, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x56 += einsum(x55, (0, 1, 2, 3), (0, 2, 1, 3))
    del x55
    x57 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x57 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    x58 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x58 += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 5, 1), (2, 4, 0, 5))
    x58 += einsum(x57, (0, 1, 2, 3), (0, 1, 3, 2)) * 0.25
    x59 = np.zeros((nocc[0], nocc[0], nocc[1], nocc[1]), dtype=types[float])
    x59 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    x60 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x60 += einsum(l1.aa, (0, 1), t2.abab, (2, 3, 0, 4), (1, 2, 3, 4))
    x60 += einsum(x49, (0, 1, 2, 3), (0, 1, 2, 3))
    x60 += einsum(t2.abab, (0, 1, 2, 3), x0, (4, 0, 5, 2), (4, 5, 1, 3)) * -2.0
    x60 += einsum(t2.bbbb, (0, 1, 2, 3), x49, (4, 5, 1, 3), (4, 5, 0, 2)) * 2.0
    x60 += einsum(t2.abab, (0, 1, 2, 3), x1, (4, 1, 5, 2), (4, 0, 5, 3)) * -1.0
    x60 += einsum(t1.bb, (0, 1), x59, (2, 3, 0, 4), (2, 3, 4, 1)) * -1.0
    x61 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x61 += einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 0), (2, 3))
    x62 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x62 += einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    x63 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x63 += einsum(t2.aaaa, (0, 1, 2, 3), x0, (0, 1, 4, 3), (4, 2)) * -1.0
    x64 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x64 += einsum(t2.abab, (0, 1, 2, 3), x49, (0, 4, 1, 3), (4, 2))
    x65 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x65 += einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    l1new_aa += einsum(x33, (0, 1), x65, (2, 0), (1, 2)) * -1.0
    x66 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x66 += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    x67 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x67 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    x68 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x68 += einsum(x65, (0, 1), (0, 1))
    x68 += einsum(x66, (0, 1), (0, 1)) * 2.0
    x68 += einsum(x67, (0, 1), (0, 1))
    x69 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x69 += einsum(t1.aa, (0, 1), x68, (0, 2), (2, 1))
    x70 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x70 += einsum(t1.aa, (0, 1), (0, 1)) * -1.0
    x70 += einsum(x61, (0, 1), (0, 1)) * -2.0
    x70 += einsum(x62, (0, 1), (0, 1)) * -1.0
    x70 += einsum(x63, (0, 1), (0, 1)) * 2.0
    x70 += einsum(x64, (0, 1), (0, 1))
    x70 += einsum(x69, (0, 1), (0, 1))
    x71 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x71 += einsum(x52, (0, 1, 2, 3), (1, 0, 3, 2))
    x71 += einsum(x50, (0, 1, 2, 3), (2, 1, 0, 3))
    x72 = np.zeros((nocc[0], nocc[0], nocc[1], nocc[1]), dtype=types[float])
    x72 += einsum(x59, (0, 1, 2, 3), (0, 1, 2, 3))
    x72 += einsum(x51, (0, 1, 2, 3), (0, 1, 2, 3))
    l2new_abab += einsum(x35, (0, 1, 2, 3), x72, (4, 0, 5, 1), (2, 3, 4, 5))
    x73 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x73 += einsum(l1.aa, (0, 1), v.aaa.xvv, (2, 3, 0), (1, 3, 2))
    x74 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x74 += einsum(x68, (0, 1), v.aaa.xov, (2, 1, 3), (0, 3, 2))
    x75 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x75 += einsum(x73, (0, 1, 2), (0, 1, 2))
    x75 += einsum(x74, (0, 1, 2), (0, 1, 2)) * -1.0
    del x74
    x76 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x76 += einsum(x65, (0, 1), (0, 1)) * 0.5
    del x65
    x76 += einsum(x66, (0, 1), (0, 1))
    x76 += einsum(x67, (0, 1), (0, 1)) * 0.5
    l1new_aa += einsum(f.aa.ov, (0, 1), x76, (2, 0), (1, 2)) * -2.0
    x77 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x77 += einsum(x66, (0, 1), (0, 1))
    del x66
    x77 += einsum(x67, (0, 1), (0, 1)) * 0.5
    del x67
    x78 = np.zeros((nocc[0], nocc[0], naux), dtype=types[float])
    x78 += einsum(x4, (0, 1, 2), x0, (3, 0, 4, 1), (4, 3, 2)) * -1.0
    x78 += einsum(v.abb.xvv, (0, 1, 2), x48, (3, 4, 1, 2), (4, 3, 0)) * 0.5
    del x48
    x78 += einsum(x9, (0, 1, 2), x49, (3, 4, 0, 1), (4, 3, 2)) * 0.5
    x78 += einsum(x2, (0, 1, 2), x50, (0, 3, 1, 4), (4, 3, 2)) * -1.0
    x78 += einsum(x3, (0, 1, 2), x51, (3, 4, 0, 1), (4, 3, 2)) * -0.5
    x78 += einsum(v.aaa.xov, (0, 1, 2), x56, (3, 1, 4, 2), (4, 3, 0))
    del x56
    x78 += einsum(v.aaa.xvv, (0, 1, 2), x58, (3, 4, 1, 2), (4, 3, 0)) * 2.0
    del x58
    x78 += einsum(v.abb.xov, (0, 1, 2), x60, (3, 4, 1, 2), (4, 3, 0)) * 0.5
    del x60
    x78 += einsum(x70, (0, 1), v.aaa.xov, (2, 3, 1), (0, 3, 2)) * -0.5
    del x70
    x78 += einsum(v.aaa.xoo, (0, 1, 2), x71, (2, 3, 1, 4), (4, 3, 0)) * -1.0
    del x71
    x78 += einsum(v.abb.xoo, (0, 1, 2), x72, (3, 4, 1, 2), (4, 3, 0)) * -0.5
    del x72
    x78 += einsum(t1.aa, (0, 1), x75, (2, 1, 3), (0, 2, 3)) * 0.5
    x78 += einsum(x76, (0, 1), v.aaa.xoo, (2, 3, 0), (1, 3, 2)) * -1.0
    x78 += einsum(x32, (0,), x77, (1, 2), (2, 1, 0))
    del x77
    l1new_aa += einsum(v.aaa.xov, (0, 1, 2), x78, (1, 3, 0), (2, 3)) * -2.0
    del x78
    x79 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x79 += einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    x80 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x80 += einsum(x79, (0, 1), (0, 1))
    del x79
    x80 += einsum(x14, (0, 1), (1, 0)) * 2.0
    del x14
    x80 += einsum(x15, (0, 1), (0, 1))
    del x15
    x81 = np.zeros((naux,), dtype=types[float])
    x81 += einsum(x80, (0, 1), v.aaa.xvv, (2, 0, 1), (2,))
    del x80
    x82 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x82 += einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    x83 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x83 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    x84 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x84 += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    x85 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x85 += einsum(x82, (0, 1), (0, 1))
    del x82
    x85 += einsum(x83, (0, 1), (1, 0))
    x85 += einsum(x84, (0, 1), (1, 0)) * 2.0
    x86 = np.zeros((naux,), dtype=types[float])
    x86 += einsum(x85, (0, 1), v.abb.xvv, (2, 1, 0), (2,))
    del x85
    x87 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x87 += einsum(l1.aa, (0, 1), (1, 0)) * -1.0
    x87 += einsum(t1.aa, (0, 1), (0, 1)) * -1.0
    x87 += einsum(x61, (0, 1), (0, 1)) * -2.0
    del x61
    x87 += einsum(x62, (0, 1), (0, 1)) * -1.0
    del x62
    x87 += einsum(x63, (0, 1), (0, 1)) * 2.0
    del x63
    x87 += einsum(x64, (0, 1), (0, 1))
    del x64
    x87 += einsum(x69, (0, 1), (0, 1))
    del x69
    x88 = np.zeros((naux,), dtype=types[float])
    x88 += einsum(x87, (0, 1), v.aaa.xov, (2, 0, 1), (2,))
    del x87
    x89 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x89 += einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    x90 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x90 += einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3))
    x91 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x91 += einsum(t2.abab, (0, 1, 2, 3), x1, (0, 1, 4, 2), (4, 3))
    x92 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x92 += einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    x93 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x93 += einsum(t2.bbbb, (0, 1, 2, 3), x92, (0, 1, 4, 3), (4, 2)) * -1.0
    x94 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x94 += einsum(l1.bb, (0, 1), t1.bb, (2, 0), (1, 2))
    x95 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x95 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    x96 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x96 += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    x97 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x97 += einsum(x94, (0, 1), (0, 1)) * 0.5
    x97 += einsum(x95, (0, 1), (0, 1)) * 0.5
    x97 += einsum(x96, (0, 1), (0, 1))
    x98 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x98 += einsum(t1.bb, (0, 1), x97, (0, 2), (2, 1)) * 2.0
    x99 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x99 += einsum(l1.bb, (0, 1), (1, 0)) * -1.0
    x99 += einsum(t1.bb, (0, 1), (0, 1)) * -1.0
    x99 += einsum(x89, (0, 1), (0, 1)) * -1.0
    x99 += einsum(x90, (0, 1), (0, 1)) * -2.0
    x99 += einsum(x91, (0, 1), (0, 1))
    x99 += einsum(x93, (0, 1), (0, 1)) * 2.0
    x99 += einsum(x98, (0, 1), (0, 1))
    x100 = np.zeros((naux,), dtype=types[float])
    x100 += einsum(x99, (0, 1), v.abb.xov, (2, 0, 1), (2,))
    del x99
    x101 = np.zeros((naux,), dtype=types[float])
    x101 += einsum(x76, (0, 1), v.aaa.xoo, (2, 1, 0), (2,)) * 2.0
    del x76
    x102 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x102 += einsum(x94, (0, 1), (0, 1))
    x102 += einsum(x95, (0, 1), (1, 0))
    x102 += einsum(x96, (0, 1), (0, 1)) * 2.0
    x103 = np.zeros((naux,), dtype=types[float])
    x103 += einsum(x102, (0, 1), v.abb.xoo, (2, 0, 1), (2,))
    del x102
    x104 = np.zeros((naux,), dtype=types[float])
    x104 += einsum(x81, (0,), (0,))
    del x81
    x104 += einsum(x86, (0,), (0,))
    del x86
    x104 += einsum(x88, (0,), (0,)) * -1.0
    del x88
    x104 += einsum(x100, (0,), (0,)) * -1.0
    del x100
    x104 += einsum(x101, (0,), (0,)) * -1.0
    del x101
    x104 += einsum(x103, (0,), (0,)) * -1.0
    del x103
    l1new_aa += einsum(x104, (0,), v.aaa.xov, (0, 1, 2), (2, 1))
    l1new_bb += einsum(x104, (0,), v.abb.xov, (0, 1, 2), (2, 1))
    del x104
    x105 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x105 += einsum(x32, (0,), v.aaa.xvv, (0, 1, 2), (1, 2))
    x106 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x106 += einsum(f.aa.vv, (0, 1), (0, 1))
    x106 += einsum(x105, (0, 1), (1, 0))
    l1new_aa += einsum(l1.aa, (0, 1), x106, (0, 2), (2, 1))
    del x106
    x107 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x107 += einsum(t1.aa, (0, 1), v.aaa.xoo, (2, 3, 0), (3, 1, 2))
    x108 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x108 += einsum(x107, (0, 1, 2), (0, 1, 2)) * -1.0
    del x107
    x108 += einsum(x5, (0, 1, 2), (0, 1, 2)) * 2.0
    x108 += einsum(x6, (0, 1, 2), (0, 1, 2))
    x109 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x109 += einsum(v.aaa.xov, (0, 1, 2), x108, (3, 2, 0), (3, 1))
    del x108
    x110 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x110 += einsum(x32, (0,), v.aaa.xoo, (0, 1, 2), (1, 2))
    x111 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x111 += einsum(t1.aa, (0, 1), x34, (2, 1), (0, 2))
    del x34
    x112 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x112 += einsum(f.aa.oo, (0, 1), (0, 1))
    x112 += einsum(x109, (0, 1), (0, 1))
    x112 += einsum(x110, (0, 1), (1, 0))
    x112 += einsum(x111, (0, 1), (0, 1))
    del x111
    l1new_aa += einsum(l1.aa, (0, 1), x112, (1, 2), (0, 2)) * -1.0
    l2new_abab += einsum(x112, (0, 1), l2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -1.0
    del x112
    x113 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x113 += einsum(x83, (0, 1), (0, 1))
    del x83
    x113 += einsum(x84, (0, 1), (0, 1)) * 2.0
    del x84
    x114 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x114 += einsum(x113, (0, 1), v.abb.xov, (2, 3, 1), (3, 0, 2)) * 0.5
    x115 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x115 += einsum(v.aaa.xoo, (0, 1, 2), x49, (1, 2, 3, 4), (3, 4, 0)) * -0.5
    x115 += einsum(v.abb.xoo, (0, 1, 2), x92, (1, 3, 2, 4), (3, 4, 0))
    x115 += einsum(x2, (0, 1, 2), x49, (0, 1, 3, 4), (3, 4, 2)) * -0.5
    x115 += einsum(x3, (0, 1, 2), x92, (3, 0, 1, 4), (3, 4, 2)) * -1.0
    x115 += einsum(x7, (0, 1, 2), l2.abab, (1, 3, 0, 4), (4, 3, 2)) * 0.5
    x115 += einsum(x12, (0, 1, 2), l2.bbbb, (3, 1, 4, 0), (4, 3, 2))
    x115 += einsum(x114, (0, 1, 2), (0, 1, 2)) * -1.0
    x115 += einsum(l1.bb, (0, 1), x25, (1, 2, 3), (2, 0, 3)) * -0.5
    l1new_bb += einsum(v.abb.xvv, (0, 1, 2), x115, (3, 2, 0), (1, 3)) * 2.0
    del x115
    x116 = np.zeros((nocc[1], nvir[0], nvir[0], nvir[1]), dtype=types[float])
    x116 += einsum(v.abb.xov, (0, 1, 2), v.aaa.xvv, (0, 3, 4), (1, 3, 4, 2))
    l2new_abab += einsum(x1, (0, 1, 2, 3), x116, (2, 4, 3, 5), (4, 5, 0, 1)) * -1.0
    x117 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x117 += einsum(v.abb.xoo, (0, 1, 2), v.abb.xov, (0, 3, 4), (1, 2, 3, 4))
    x118 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x118 += einsum(v.abb.xov, (0, 1, 2), x3, (3, 4, 0), (3, 1, 4, 2))
    x119 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x119 += einsum(x117, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x119 += einsum(x117, (0, 1, 2, 3), (1, 2, 0, 3))
    x119 += einsum(x118, (0, 1, 2, 3), (0, 1, 2, 3))
    x119 += einsum(x118, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    x120 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x120 += einsum(v.aaa.xov, (0, 1, 2), (1, 2, 0))
    x120 += einsum(x4, (0, 1, 2), (0, 1, 2))
    x121 = np.zeros((nocc[1], nocc[1], naux), dtype=types[float])
    x121 += einsum(v.abb.xoo, (0, 1, 2), (1, 2, 0))
    x121 += einsum(x3, (0, 1, 2), (1, 0, 2))
    x122 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x122 += einsum(v.aaa.xov, (0, 1, 2), x121, (3, 4, 0), (1, 3, 4, 2))
    l2new_abab += einsum(x122, (0, 1, 2, 3), x49, (4, 0, 2, 5), (3, 5, 4, 1))
    l2new_abab += einsum(l1.bb, (0, 1), x122, (2, 3, 1, 4), (4, 0, 2, 3)) * -1.0
    x123 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x123 += einsum(v.abb.xov, (0, 1, 2), x18, (3, 4, 0), (4, 3, 1, 2))
    x124 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x124 += einsum(v.abb.xov, (0, 1, 2), x3, (1, 3, 0), (3, 2))
    x125 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x125 += einsum(x32, (0,), v.abb.xov, (0, 1, 2), (1, 2))
    l1new_bb += einsum(x125, (0, 1), x94, (2, 0), (1, 2)) * -1.0
    x126 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x126 += einsum(f.bb.ov, (0, 1), (0, 1))
    x126 += einsum(x124, (0, 1), (0, 1)) * -1.0
    x126 += einsum(x125, (0, 1), (0, 1))
    l2new_abab += einsum(x126, (0, 1), x1, (2, 3, 0, 4), (4, 1, 2, 3)) * -1.0
    l2new_abab += einsum(l1.aa, (0, 1), x126, (2, 3), (0, 3, 1, 2))
    x127 = np.zeros((nocc[0], nocc[0], nocc[1], nocc[1]), dtype=types[float])
    x127 += einsum(x36, (0, 1, 2, 3), (1, 0, 2, 3))
    x127 += einsum(x121, (0, 1, 2), x18, (3, 4, 2), (4, 3, 1, 0))
    del x18
    x128 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x128 += einsum(t2.abab, (0, 1, 2, 3), x116, (4, 5, 2, 3), (0, 4, 1, 5))
    del x116
    x128 += einsum(t2.abab, (0, 1, 2, 3), x119, (4, 5, 1, 3), (0, 5, 4, 2)) * -1.0
    del x119
    x128 += einsum(x120, (0, 1, 2), x25, (3, 4, 2), (0, 4, 3, 1))
    del x120
    x128 += einsum(t2.aaaa, (0, 1, 2, 3), x122, (1, 4, 5, 3), (0, 4, 5, 2)) * 2.0
    x128 += einsum(t2.abab, (0, 1, 2, 3), x123, (0, 4, 5, 3), (4, 5, 1, 2)) * -1.0
    del x123
    x128 += einsum(x126, (0, 1), t2.abab, (2, 3, 4, 1), (2, 0, 3, 4))
    x128 += einsum(t1.aa, (0, 1), x127, (0, 2, 3, 4), (2, 4, 3, 1)) * -1.0
    del x127
    l1new_bb += einsum(l2.abab, (0, 1, 2, 3), x128, (2, 4, 3, 0), (1, 4)) * -1.0
    del x128
    x129 = np.zeros((nocc[1], nvir[1], nvir[1], nvir[1]), dtype=types[float])
    x129 += einsum(v.abb.xov, (0, 1, 2), v.abb.xvv, (0, 3, 4), (1, 2, 3, 4))
    x130 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x130 += einsum(x117, (0, 1, 2, 3), (1, 0, 2, 3))
    x130 += einsum(x117, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    x130 += einsum(x118, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x130 += einsum(x118, (0, 1, 2, 3), (0, 2, 1, 3))
    x131 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x131 += einsum(v.abb.xoo, (0, 1, 2), v.abb.xoo, (0, 3, 4), (1, 3, 4, 2))
    x132 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x132 += einsum(v.abb.xov, (0, 1, 2), v.abb.xov, (0, 3, 4), (1, 3, 2, 4))
    x133 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x133 += einsum(t2.bbbb, (0, 1, 2, 3), x132, (4, 5, 3, 2), (0, 1, 5, 4))
    x134 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x134 += einsum(x3, (0, 1, 2), x3, (3, 4, 2), (0, 3, 1, 4))
    x135 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x135 += einsum(v.abb.xoo, (0, 1, 2), x3, (3, 4, 0), (3, 1, 2, 4))
    x136 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x136 += einsum(x131, (0, 1, 2, 3), (3, 2, 1, 0))
    x136 += einsum(x133, (0, 1, 2, 3), (2, 3, 1, 0))
    x136 += einsum(x134, (0, 1, 2, 3), (2, 3, 1, 0))
    x136 += einsum(x135, (0, 1, 2, 3), (1, 3, 0, 2))
    x136 += einsum(x135, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    x137 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x137 += einsum(v.abb.xoo, (0, 1, 2), x9, (3, 4, 0), (1, 2, 3, 4)) * -1.0
    x137 += einsum(t2.bbbb, (0, 1, 2, 3), x129, (4, 2, 3, 5), (4, 0, 1, 5)) * -1.0
    x137 += einsum(x3, (0, 1, 2), x9, (3, 4, 2), (1, 3, 0, 4))
    x137 += einsum(t2.bbbb, (0, 1, 2, 3), x130, (4, 1, 5, 3), (5, 0, 4, 2)) * -2.0
    del x130
    x137 += einsum(t2.abab, (0, 1, 2, 3), x122, (0, 4, 5, 2), (4, 1, 5, 3))
    del x122
    x137 += einsum(v.abb.xov, (0, 1, 2), x25, (3, 4, 0), (4, 1, 3, 2))
    del x25
    x137 += einsum(x126, (0, 1), t2.bbbb, (2, 3, 4, 1), (0, 2, 3, 4))
    x137 += einsum(t1.bb, (0, 1), x136, (0, 2, 3, 4), (2, 4, 3, 1)) * -1.0
    del x136
    l1new_bb += einsum(l2.bbbb, (0, 1, 2, 3), x137, (4, 2, 3, 1), (0, 4)) * 2.0
    del x137
    x138 = np.zeros((nocc[1], nocc[1], nvir[0], nvir[0]), dtype=types[float])
    x138 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (3, 4, 0, 5))
    x139 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x139 += einsum(t1.bb, (0, 1), x92, (2, 3, 4, 1), (2, 3, 0, 4))
    x140 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x140 += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    x141 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x141 += einsum(t2.abab, (0, 1, 2, 3), x1, (0, 4, 5, 2), (4, 5, 1, 3))
    x142 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x142 += einsum(t2.bbbb, (0, 1, 2, 3), x92, (4, 1, 5, 3), (4, 5, 0, 2)) * -1.0
    x143 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x143 += einsum(x141, (0, 1, 2, 3), (0, 1, 2, 3)) * 0.5
    del x141
    x143 += einsum(x142, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x142
    x144 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x144 += einsum(l1.bb, (0, 1), t2.bbbb, (2, 3, 4, 0), (1, 2, 3, 4))
    x144 += einsum(x92, (0, 1, 2, 3), (1, 0, 2, 3))
    x144 += einsum(t1.bb, (0, 1), x140, (2, 0, 3, 4), (2, 3, 4, 1))
    x144 += einsum(x143, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x144 += einsum(x143, (0, 1, 2, 3), (0, 2, 1, 3))
    del x143
    x145 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x145 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    x146 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x146 += einsum(x145, (0, 1, 2, 3), (0, 1, 2, 3))
    x146 += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 5, 0)) * 4.0
    x147 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x147 += einsum(l1.bb, (0, 1), t2.abab, (2, 3, 4, 0), (2, 1, 3, 4))
    x147 += einsum(x1, (0, 1, 2, 3), (0, 1, 2, 3))
    x147 += einsum(t2.aaaa, (0, 1, 2, 3), x1, (1, 4, 5, 3), (0, 4, 5, 2)) * 2.0
    x147 += einsum(t2.abab, (0, 1, 2, 3), x49, (0, 4, 5, 3), (4, 5, 1, 2)) * -1.0
    x147 += einsum(t1.aa, (0, 1), x59, (0, 2, 3, 4), (2, 3, 4, 1)) * -1.0
    x147 += einsum(t2.abab, (0, 1, 2, 3), x92, (4, 1, 5, 3), (0, 4, 5, 2)) * -2.0
    x148 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x148 += einsum(t1.bb, (0, 1), (0, 1)) * -1.0
    x148 += einsum(x89, (0, 1), (0, 1)) * -1.0
    del x89
    x148 += einsum(x90, (0, 1), (0, 1)) * -2.0
    del x90
    x148 += einsum(x91, (0, 1), (0, 1))
    del x91
    x148 += einsum(x93, (0, 1), (0, 1)) * 2.0
    del x93
    x148 += einsum(x98, (0, 1), (0, 1))
    del x98
    x149 = np.zeros((nocc[0], nocc[0], nocc[1], nocc[1]), dtype=types[float])
    x149 += einsum(x59, (0, 1, 2, 3), (0, 1, 2, 3))
    del x59
    x149 += einsum(x51, (0, 1, 2, 3), (1, 0, 2, 3))
    x150 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x150 += einsum(x140, (0, 1, 2, 3), (1, 0, 3, 2))
    x150 += einsum(x139, (0, 1, 2, 3), (2, 1, 0, 3))
    x151 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x151 += einsum(l1.bb, (0, 1), v.abb.xvv, (2, 3, 0), (1, 3, 2))
    x152 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x152 += einsum(x97, (0, 1), v.abb.xov, (2, 1, 3), (0, 3, 2)) * 2.0
    del x97
    x153 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x153 += einsum(x151, (0, 1, 2), (0, 1, 2))
    x153 += einsum(x152, (0, 1, 2), (0, 1, 2)) * -1.0
    x154 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x154 += einsum(x94, (0, 1), (0, 1))
    del x94
    x154 += einsum(x95, (0, 1), (0, 1))
    x154 += einsum(x96, (0, 1), (0, 1)) * 2.0
    l1new_bb += einsum(f.bb.ov, (0, 1), x154, (2, 0), (1, 2)) * -1.0
    x155 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x155 += einsum(x95, (0, 1), (0, 1)) * 0.5
    del x95
    x155 += einsum(x96, (0, 1), (0, 1))
    del x96
    x156 = np.zeros((nocc[1], nocc[1], naux), dtype=types[float])
    x156 += einsum(v.aaa.xvv, (0, 1, 2), x138, (3, 4, 1, 2), (4, 3, 0))
    del x138
    x156 += einsum(x4, (0, 1, 2), x1, (0, 3, 4, 1), (4, 3, 2))
    x156 += einsum(x9, (0, 1, 2), x92, (3, 0, 4, 1), (4, 3, 2)) * -2.0
    x156 += einsum(x2, (0, 1, 2), x51, (0, 1, 3, 4), (4, 3, 2)) * -1.0
    del x51
    x156 += einsum(x3, (0, 1, 2), x139, (0, 3, 1, 4), (4, 3, 2)) * -2.0
    x156 += einsum(v.abb.xov, (0, 1, 2), x144, (3, 1, 4, 2), (4, 3, 0)) * 2.0
    del x144
    x156 += einsum(v.abb.xvv, (0, 1, 2), x146, (3, 4, 1, 2), (4, 3, 0))
    del x146
    x156 += einsum(v.aaa.xov, (0, 1, 2), x147, (1, 3, 4, 2), (4, 3, 0))
    del x147
    x156 += einsum(x148, (0, 1), v.abb.xov, (2, 3, 1), (0, 3, 2)) * -1.0
    del x148
    x156 += einsum(v.aaa.xoo, (0, 1, 2), x149, (1, 2, 3, 4), (4, 3, 0)) * -1.0
    del x149
    x156 += einsum(v.abb.xoo, (0, 1, 2), x150, (1, 3, 2, 4), (4, 3, 0)) * -2.0
    del x150
    x156 += einsum(t1.bb, (0, 1), x153, (2, 1, 3), (0, 2, 3))
    x156 += einsum(x154, (0, 1), v.abb.xoo, (2, 3, 0), (1, 3, 2)) * -1.0
    del x154
    x156 += einsum(x32, (0,), x155, (1, 2), (2, 1, 0)) * 2.0
    del x155
    l1new_bb += einsum(v.abb.xov, (0, 1, 2), x156, (1, 3, 0), (2, 3)) * -1.0
    del x156
    x157 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x157 += einsum(x32, (0,), v.abb.xvv, (0, 1, 2), (1, 2))
    x158 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x158 += einsum(f.bb.vv, (0, 1), (0, 1))
    x158 += einsum(x157, (0, 1), (1, 0))
    l1new_bb += einsum(l1.bb, (0, 1), x158, (0, 2), (2, 1))
    del x158
    x159 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x159 += einsum(t1.bb, (0, 1), v.abb.xoo, (2, 3, 0), (3, 1, 2))
    x160 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x160 += einsum(x159, (0, 1, 2), (0, 1, 2)) * -0.5
    del x159
    x160 += einsum(x10, (0, 1, 2), (0, 1, 2)) * 0.5
    x160 += einsum(x11, (0, 1, 2), (0, 1, 2))
    x161 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x161 += einsum(v.abb.xov, (0, 1, 2), x160, (3, 2, 0), (3, 1)) * 2.0
    x162 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x162 += einsum(x32, (0,), v.abb.xoo, (0, 1, 2), (1, 2))
    x163 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x163 += einsum(f.bb.oo, (0, 1), (0, 1))
    x163 += einsum(x161, (0, 1), (0, 1))
    x163 += einsum(x162, (0, 1), (1, 0))
    x163 += einsum(t1.bb, (0, 1), x126, (2, 1), (0, 2))
    l1new_bb += einsum(l1.bb, (0, 1), x163, (1, 2), (0, 2)) * -1.0
    del x163
    x164 = np.zeros((nvir[0], nvir[0], nvir[0], nvir[0]), dtype=types[float])
    x164 += einsum(v.aaa.xvv, (0, 1, 2), v.aaa.xvv, (0, 3, 4), (1, 3, 4, 2))
    l2new_aaaa = np.zeros((nvir[0], nvir[0], nocc[0], nocc[0]), dtype=types[float])
    l2new_aaaa += einsum(l2.aaaa, (0, 1, 2, 3), x164, (4, 5, 0, 1), (4, 5, 2, 3)) * -2.0
    del x164
    x165 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x165 += einsum(f.aa.vv, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    x166 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x166 += einsum(f.aa.ov, (0, 1), x0, (2, 3, 0, 4), (2, 3, 1, 4))
    x167 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x167 += einsum(x0, (0, 1, 2, 3), x39, (2, 4, 3, 5), (1, 0, 4, 5))
    del x39
    x168 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x168 += einsum(x4, (0, 1, 2), (0, 1, 2))
    del x4
    x168 += einsum(x5, (0, 1, 2), (0, 1, 2)) * 2.0
    del x5
    x168 += einsum(x6, (0, 1, 2), (0, 1, 2))
    del x6
    x169 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x169 += einsum(v.aaa.xov, (0, 1, 2), x168, (1, 3, 0), (3, 2))
    del x168
    x170 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x170 += einsum(x169, (0, 1), (1, 0))
    x170 += einsum(x105, (0, 1), (1, 0)) * -1.0
    x171 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x171 += einsum(x170, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2)) * -2.0
    del x170
    x172 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x172 += einsum(x29, (0, 1), (0, 1)) * -1.0
    del x29
    x172 += einsum(x33, (0, 1), (0, 1))
    del x33
    x173 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x173 += einsum(x172, (0, 1), x0, (2, 3, 0, 4), (2, 3, 1, 4)) * 2.0
    x174 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x174 += einsum(x165, (0, 1, 2, 3), (1, 0, 2, 3)) * 2.0
    del x165
    x174 += einsum(x42, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x174 += einsum(x166, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x166
    x174 += einsum(x167, (0, 1, 2, 3), (0, 1, 2, 3)) * -2.0
    del x167
    x174 += einsum(x171, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x171
    x174 += einsum(x173, (0, 1, 2, 3), (1, 0, 3, 2))
    del x173
    l2new_aaaa += einsum(x174, (0, 1, 2, 3), (2, 3, 0, 1))
    l2new_aaaa += einsum(x174, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    del x174
    x175 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x175 += einsum(v.abb.xoo, (0, 1, 2), v.aaa.xov, (0, 3, 4), (3, 1, 2, 4))
    l2new_abab += einsum(x175, (0, 1, 2, 3), x92, (4, 1, 2, 5), (3, 5, 0, 4)) * -2.0
    x176 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x176 += einsum(x1, (0, 1, 2, 3), x175, (4, 1, 2, 5), (0, 4, 3, 5))
    del x175
    x177 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x177 += einsum(x42, (0, 1, 2, 3), x57, (4, 0, 5, 3), (4, 1, 5, 2))
    del x57
    x178 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x178 += einsum(v.aaa.xov, (0, 1, 2), x3, (3, 4, 0), (1, 3, 4, 2))
    del x3
    l2new_abab += einsum(x178, (0, 1, 2, 3), x92, (4, 1, 2, 5), (3, 5, 0, 4)) * -2.0
    x179 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x179 += einsum(x1, (0, 1, 2, 3), x178, (4, 1, 2, 5), (0, 4, 3, 5))
    del x178
    x180 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x180 += einsum(x7, (0, 1, 2), l2.aaaa, (3, 1, 4, 0), (4, 3, 2))
    x181 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x181 += einsum(x12, (0, 1, 2), l2.abab, (3, 1, 4, 0), (4, 3, 2)) * 0.5
    x182 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x182 += einsum(x180, (0, 1, 2), (0, 1, 2))
    del x180
    x182 += einsum(x181, (0, 1, 2), (0, 1, 2))
    del x181
    x183 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x183 += einsum(v.aaa.xov, (0, 1, 2), x182, (3, 4, 0), (3, 1, 4, 2)) * 2.0
    del x182
    x184 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x184 += einsum(t2.aaaa, (0, 1, 2, 3), x42, (4, 1, 3, 5), (0, 4, 2, 5))
    x185 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x185 += einsum(v.aaa.xvv, (0, 1, 2), x27, (3, 4, 0), (3, 4, 1, 2))
    x186 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x186 += einsum(x184, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x184
    x186 += einsum(x185, (0, 1, 2, 3), (1, 0, 3, 2))
    del x185
    l2new_abab += einsum(l2.abab, (0, 1, 2, 3), x186, (2, 4, 0, 5), (5, 1, 4, 3)) * -1.0
    x187 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x187 += einsum(l2.aaaa, (0, 1, 2, 3), x186, (3, 4, 1, 5), (4, 2, 5, 0)) * 2.0
    del x186
    x188 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x188 += einsum(v.aaa.xov, (0, 1, 2), x75, (3, 4, 0), (1, 3, 2, 4))
    del x75
    x189 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x189 += einsum(x16, (0, 1), v.aaa.xov, (2, 3, 1), (3, 0, 2)) * 2.0
    del x16
    x190 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x190 += einsum(v.aaa.xov, (0, 1, 2), x189, (3, 4, 0), (3, 1, 4, 2)) * -1.0
    del x189
    x191 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x191 += einsum(x22, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x191 += einsum(x22, (0, 1, 2, 3), (0, 2, 1, 3))
    x192 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x192 += einsum(x0, (0, 1, 2, 3), x191, (0, 2, 4, 5), (4, 1, 5, 3)) * 2.0
    del x191
    x193 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x193 += einsum(x21, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x193 += einsum(x21, (0, 1, 2, 3), (1, 2, 0, 3))
    l2new_abab += einsum(x193, (0, 1, 2, 3), x49, (0, 2, 4, 5), (3, 5, 1, 4)) * -1.0
    x194 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x194 += einsum(x0, (0, 1, 2, 3), x193, (0, 4, 2, 5), (4, 1, 5, 3)) * 2.0
    del x193
    x195 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x195 += einsum(x21, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x21
    x195 += einsum(x22, (0, 1, 2, 3), (0, 1, 2, 3))
    x196 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x196 += einsum(l1.aa, (0, 1), x195, (1, 2, 3, 4), (2, 3, 4, 0))
    del x195
    x197 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x197 += einsum(f.aa.ov, (0, 1), l1.aa, (2, 3), (0, 3, 1, 2))
    x197 += einsum(x176, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x176
    x197 += einsum(x177, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x177
    x197 += einsum(x179, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x179
    x197 += einsum(x183, (0, 1, 2, 3), (0, 1, 2, 3))
    del x183
    x197 += einsum(x187, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x187
    x197 += einsum(x188, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x188
    x197 += einsum(x190, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x190
    x197 += einsum(x192, (0, 1, 2, 3), (1, 0, 3, 2))
    del x192
    x197 += einsum(x194, (0, 1, 2, 3), (1, 0, 3, 2))
    del x194
    x197 += einsum(x196, (0, 1, 2, 3), (0, 1, 3, 2))
    del x196
    x197 += einsum(l1.aa, (0, 1), x172, (2, 3), (1, 2, 0, 3))
    l2new_aaaa += einsum(x197, (0, 1, 2, 3), (2, 3, 0, 1))
    l2new_aaaa += einsum(x197, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    l2new_aaaa += einsum(x197, (0, 1, 2, 3), (2, 3, 1, 0)) * -1.0
    l2new_aaaa += einsum(x197, (0, 1, 2, 3), (3, 2, 1, 0))
    del x197
    x198 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x198 += einsum(f.aa.oo, (0, 1), l2.aaaa, (2, 3, 4, 1), (0, 4, 2, 3))
    l2new_aaaa += einsum(x198, (0, 1, 2, 3), (3, 2, 0, 1)) * -2.0
    l2new_aaaa += einsum(x198, (0, 1, 2, 3), (3, 2, 1, 0)) * 2.0
    del x198
    x199 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x199 += einsum(f.aa.ov, (0, 1), t1.aa, (2, 1), (0, 2))
    x200 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x200 += einsum(x199, (0, 1), l2.aaaa, (2, 3, 4, 1), (0, 4, 2, 3))
    del x199
    x201 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x201 += einsum(l2.aaaa, (0, 1, 2, 3), x45, (2, 4, 3, 5), (4, 5, 0, 1))
    del x45
    x202 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x202 += einsum(t1.aa, (0, 1), x172, (2, 1), (2, 0))
    del x172
    x203 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x203 += einsum(x109, (0, 1), (0, 1))
    del x109
    x203 += einsum(x110, (0, 1), (1, 0))
    del x110
    x203 += einsum(x202, (0, 1), (1, 0))
    del x202
    x204 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x204 += einsum(x203, (0, 1), l2.aaaa, (2, 3, 4, 0), (1, 4, 2, 3)) * -2.0
    del x203
    x205 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x205 += einsum(x200, (0, 1, 2, 3), (0, 1, 3, 2)) * 2.0
    del x200
    x205 += einsum(x201, (0, 1, 2, 3), (0, 1, 3, 2)) * -2.0
    del x201
    x205 += einsum(x204, (0, 1, 2, 3), (1, 0, 3, 2))
    del x204
    l2new_aaaa += einsum(x205, (0, 1, 2, 3), (3, 2, 0, 1))
    l2new_aaaa += einsum(x205, (0, 1, 2, 3), (3, 2, 1, 0)) * -1.0
    del x205
    x206 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x206 += einsum(x41, (0, 1, 2, 3), (3, 2, 1, 0))
    del x41
    x206 += einsum(x43, (0, 1, 2, 3), (0, 3, 1, 2))
    del x43
    x206 += einsum(x44, (0, 1, 2, 3), (0, 3, 1, 2))
    del x44
    l2new_aaaa += einsum(l2.aaaa, (0, 1, 2, 3), x206, (2, 4, 3, 5), (0, 1, 4, 5)) * -2.0
    del x206
    x207 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x207 += einsum(x52, (0, 1, 2, 3), (1, 0, 3, 2))
    del x52
    x207 += einsum(x50, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x50
    l2new_aaaa += einsum(x207, (0, 1, 2, 3), x42, (2, 3, 4, 5), (5, 4, 1, 0)) * 2.0
    del x207
    x208 = np.zeros((nvir[0], nvir[0], nvir[1], nvir[1]), dtype=types[float])
    x208 += einsum(v.aaa.xvv, (0, 1, 2), v.abb.xvv, (0, 3, 4), (1, 2, 3, 4))
    l2new_abab += einsum(l2.abab, (0, 1, 2, 3), x208, (4, 0, 1, 5), (4, 5, 2, 3))
    del x208
    x209 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x209 += einsum(l2.bbbb, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (4, 2, 5, 0))
    l2new_abab += einsum(x209, (0, 1, 2, 3), x42, (4, 0, 2, 5), (5, 3, 4, 1)) * -2.0
    del x42, x209
    x210 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x210 += einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    l2new_abab += einsum(x132, (0, 1, 2, 3), x210, (4, 1, 5, 2), (5, 3, 4, 0)) * -2.0
    del x210
    x211 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x211 += einsum(v.abb.xov, (0, 1, 2), x2, (3, 4, 0), (3, 4, 1, 2))
    del x2
    l2new_abab += einsum(x0, (0, 1, 2, 3), x211, (1, 2, 4, 5), (3, 5, 0, 4)) * -2.0
    x212 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x212 += einsum(v.aaa.xoo, (0, 1, 2), v.abb.xov, (0, 3, 4), (1, 2, 3, 4))
    l2new_abab += einsum(x0, (0, 1, 2, 3), x212, (1, 2, 4, 5), (3, 5, 0, 4)) * -2.0
    del x0
    x213 = np.zeros((nocc[0], nvir[0], naux), dtype=types[float])
    x213 += einsum(v.aaa.xov, (0, 1, 2), (1, 2, 0)) * 0.25
    x213 += einsum(x73, (0, 1, 2), (0, 1, 2)) * 0.25
    del x73
    x213 += einsum(x8, (0, 1, 2), (0, 1, 2))
    del x8
    x213 += einsum(x13, (0, 1, 2), (0, 1, 2))
    del x13
    x213 += einsum(x17, (0, 1, 2), (0, 1, 2)) * -1.0
    del x17
    x213 += einsum(x68, (0, 1), v.aaa.xov, (2, 1, 3), (0, 3, 2)) * -0.25
    del x68
    l2new_abab += einsum(v.abb.xov, (0, 1, 2), x213, (3, 4, 0), (4, 2, 3, 1)) * 4.0
    del x213
    x214 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x214 += einsum(x7, (0, 1, 2), l2.abab, (1, 3, 0, 4), (4, 3, 2))
    del x7
    x215 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x215 += einsum(x12, (0, 1, 2), l2.bbbb, (3, 1, 4, 0), (4, 3, 2)) * 2.0
    del x12
    x216 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x216 += einsum(x151, (0, 1, 2), (0, 1, 2))
    del x151
    x216 += einsum(x214, (0, 1, 2), (0, 1, 2))
    x216 += einsum(x215, (0, 1, 2), (0, 1, 2))
    x216 += einsum(x113, (0, 1), v.abb.xov, (2, 3, 1), (3, 0, 2)) * -1.0
    del x113
    x216 += einsum(x152, (0, 1, 2), (0, 1, 2)) * -1.0
    del x152
    l2new_abab += einsum(v.aaa.xov, (0, 1, 2), x216, (3, 4, 0), (2, 4, 1, 3))
    del x216
    x217 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x217 += einsum(t2.bbbb, (0, 1, 2, 3), x132, (4, 1, 3, 5), (0, 4, 2, 5))
    x218 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x218 += einsum(v.abb.xvv, (0, 1, 2), x121, (3, 4, 0), (3, 4, 1, 2))
    x219 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x219 += einsum(x217, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x217
    x219 += einsum(x218, (0, 1, 2, 3), (1, 0, 3, 2))
    del x218
    l2new_abab += einsum(l2.abab, (0, 1, 2, 3), x219, (3, 4, 1, 5), (0, 5, 2, 4)) * -1.0
    x220 = np.zeros((nocc[1], nocc[1], nvir[0], nvir[0]), dtype=types[float])
    x220 += einsum(t2.abab, (0, 1, 2, 3), x35, (0, 4, 5, 3), (1, 4, 2, 5)) * -1.0
    x220 += einsum(v.aaa.xvv, (0, 1, 2), x121, (3, 4, 0), (4, 3, 1, 2))
    l2new_abab += einsum(l2.abab, (0, 1, 2, 3), x220, (3, 4, 0, 5), (5, 1, 2, 4)) * -1.0
    del x220
    x221 = np.zeros((nocc[0], nocc[0], nvir[1], nvir[1]), dtype=types[float])
    x221 += einsum(t2.abab, (0, 1, 2, 3), x35, (4, 1, 2, 5), (0, 4, 3, 5)) * -1.0
    del x35
    x221 += einsum(v.abb.xvv, (0, 1, 2), x27, (3, 4, 0), (4, 3, 1, 2))
    l2new_abab += einsum(l2.abab, (0, 1, 2, 3), x221, (2, 4, 1, 5), (0, 5, 4, 3)) * -1.0
    del x221
    x222 = np.zeros((nocc[0], nocc[0], nocc[1], nocc[1]), dtype=types[float])
    x222 += einsum(x36, (0, 1, 2, 3), (0, 1, 2, 3))
    del x36
    x222 += einsum(x121, (0, 1, 2), x27, (3, 4, 2), (4, 3, 1, 0))
    del x27, x121
    l2new_abab += einsum(l2.abab, (0, 1, 2, 3), x222, (2, 4, 3, 5), (0, 1, 4, 5))
    del x222
    x223 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x223 += einsum(f.aa.vv, (0, 1), (0, 1)) * -1.0
    x223 += einsum(x169, (0, 1), (0, 1))
    del x169
    x223 += einsum(x105, (0, 1), (1, 0)) * -1.0
    del x105
    l2new_abab += einsum(x223, (0, 1), l2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1.0
    del x223
    x224 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x224 += einsum(x9, (0, 1, 2), (0, 1, 2)) * 0.5
    x224 += einsum(x10, (0, 1, 2), (0, 1, 2)) * 0.5
    x224 += einsum(x11, (0, 1, 2), (0, 1, 2))
    x225 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x225 += einsum(f.bb.vv, (0, 1), (0, 1)) * -1.0
    x225 += einsum(v.abb.xov, (0, 1, 2), x224, (1, 3, 0), (3, 2)) * 2.0
    del x224
    x225 += einsum(x157, (0, 1), (1, 0)) * -1.0
    l2new_abab += einsum(x225, (0, 1), l2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -1.0
    del x225
    x226 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x226 += einsum(x118, (0, 1, 2, 3), (0, 1, 2, 3))
    x226 += einsum(x118, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    l2new_abab += einsum(x1, (0, 1, 2, 3), x226, (1, 4, 2, 5), (3, 5, 0, 4)) * -1.0
    del x226
    x227 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x227 += einsum(x117, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x227 += einsum(x117, (0, 1, 2, 3), (1, 2, 0, 3))
    l2new_abab += einsum(x1, (0, 1, 2, 3), x227, (1, 4, 2, 5), (3, 5, 0, 4)) * -1.0
    del x1, x227
    x228 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x228 += einsum(x22, (0, 1, 2, 3), (0, 1, 2, 3))
    x228 += einsum(x22, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    del x22
    l2new_abab += einsum(x228, (0, 1, 2, 3), x49, (0, 2, 4, 5), (3, 5, 1, 4)) * -1.0
    del x228
    x229 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x229 += einsum(f.bb.oo, (0, 1), (0, 1)) * 0.5
    x229 += einsum(v.abb.xov, (0, 1, 2), x160, (3, 2, 0), (3, 1))
    del x160
    x229 += einsum(x32, (0,), v.abb.xoo, (0, 1, 2), (1, 2)) * 0.5
    del x32
    x229 += einsum(t1.bb, (0, 1), x126, (2, 1), (0, 2)) * 0.5
    del x126
    l2new_abab += einsum(x229, (0, 1), l2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -2.0
    del x229
    x230 = np.zeros((nvir[1], nvir[1], nvir[1], nvir[1]), dtype=types[float])
    x230 += einsum(v.abb.xvv, (0, 1, 2), v.abb.xvv, (0, 3, 4), (1, 3, 4, 2))
    l2new_bbbb = np.zeros((nvir[1], nvir[1], nocc[1], nocc[1]), dtype=types[float])
    l2new_bbbb += einsum(l2.bbbb, (0, 1, 2, 3), x230, (4, 5, 0, 1), (4, 5, 2, 3)) * -2.0
    del x230
    x231 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x231 += einsum(f.bb.vv, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    x232 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x232 += einsum(f.bb.ov, (0, 1), x92, (2, 3, 0, 4), (2, 3, 1, 4))
    x233 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x233 += einsum(x129, (0, 1, 2, 3), x92, (4, 5, 0, 2), (5, 4, 1, 3))
    del x129
    x234 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x234 += einsum(x9, (0, 1, 2), (0, 1, 2))
    del x9
    x234 += einsum(x10, (0, 1, 2), (0, 1, 2))
    del x10
    x234 += einsum(x11, (0, 1, 2), (0, 1, 2)) * 2.0
    del x11
    x235 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x235 += einsum(v.abb.xov, (0, 1, 2), x234, (1, 3, 0), (3, 2))
    del x234
    x236 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x236 += einsum(x235, (0, 1), (1, 0))
    del x235
    x236 += einsum(x157, (0, 1), (1, 0)) * -1.0
    del x157
    x237 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x237 += einsum(x236, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2)) * -2.0
    del x236
    x238 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x238 += einsum(x124, (0, 1), (0, 1)) * -1.0
    del x124
    x238 += einsum(x125, (0, 1), (0, 1))
    del x125
    x239 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x239 += einsum(x238, (0, 1), x92, (2, 3, 0, 4), (2, 3, 1, 4)) * 2.0
    x240 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x240 += einsum(x231, (0, 1, 2, 3), (1, 0, 2, 3)) * 2.0
    del x231
    x240 += einsum(x132, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x240 += einsum(x232, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x232
    x240 += einsum(x233, (0, 1, 2, 3), (0, 1, 2, 3)) * -2.0
    del x233
    x240 += einsum(x237, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x237
    x240 += einsum(x239, (0, 1, 2, 3), (1, 0, 3, 2))
    del x239
    l2new_bbbb += einsum(x240, (0, 1, 2, 3), (2, 3, 0, 1))
    l2new_bbbb += einsum(x240, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    del x240
    x241 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x241 += einsum(x212, (0, 1, 2, 3), x49, (0, 1, 4, 5), (4, 2, 5, 3))
    del x212
    x242 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x242 += einsum(x211, (0, 1, 2, 3), x49, (0, 1, 4, 5), (4, 2, 5, 3))
    del x49, x211
    x243 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x243 += einsum(x132, (0, 1, 2, 3), x145, (4, 0, 5, 3), (4, 1, 5, 2))
    del x145
    x244 = np.zeros((nocc[1], nvir[1], naux), dtype=types[float])
    x244 += einsum(x214, (0, 1, 2), (0, 1, 2))
    del x214
    x244 += einsum(x215, (0, 1, 2), (0, 1, 2))
    del x215
    x245 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x245 += einsum(v.abb.xov, (0, 1, 2), x244, (3, 4, 0), (3, 1, 4, 2))
    del x244
    x246 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x246 += einsum(l2.bbbb, (0, 1, 2, 3), x219, (3, 4, 1, 5), (4, 2, 5, 0)) * 2.0
    del x219
    x247 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x247 += einsum(v.abb.xov, (0, 1, 2), x153, (3, 4, 0), (3, 1, 4, 2))
    del x153
    x248 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x248 += einsum(v.abb.xov, (0, 1, 2), x114, (3, 4, 0), (3, 1, 4, 2)) * -2.0
    del x114
    x249 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x249 += einsum(x118, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x249 += einsum(x118, (0, 1, 2, 3), (0, 2, 1, 3))
    x250 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x250 += einsum(x249, (0, 1, 2, 3), x92, (0, 4, 1, 5), (2, 4, 3, 5)) * 2.0
    del x249
    x251 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x251 += einsum(x117, (0, 1, 2, 3), (1, 0, 2, 3))
    x251 += einsum(x117, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    x252 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x252 += einsum(x251, (0, 1, 2, 3), x92, (0, 4, 1, 5), (2, 4, 3, 5)) * 2.0
    del x92, x251
    x253 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x253 += einsum(x117, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x117
    x253 += einsum(x118, (0, 1, 2, 3), (0, 1, 2, 3))
    del x118
    x254 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x254 += einsum(l1.bb, (0, 1), x253, (1, 2, 3, 4), (2, 3, 4, 0))
    del x253
    x255 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x255 += einsum(f.bb.ov, (0, 1), l1.bb, (2, 3), (0, 3, 1, 2))
    x255 += einsum(x241, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x241
    x255 += einsum(x242, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x242
    x255 += einsum(x243, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x243
    x255 += einsum(x245, (0, 1, 2, 3), (0, 1, 2, 3))
    del x245
    x255 += einsum(x246, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x246
    x255 += einsum(x247, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x247
    x255 += einsum(x248, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x248
    x255 += einsum(x250, (0, 1, 2, 3), (1, 0, 3, 2))
    del x250
    x255 += einsum(x252, (0, 1, 2, 3), (1, 0, 3, 2))
    del x252
    x255 += einsum(x254, (0, 1, 2, 3), (0, 1, 3, 2))
    del x254
    x255 += einsum(l1.bb, (0, 1), x238, (2, 3), (1, 2, 0, 3))
    l2new_bbbb += einsum(x255, (0, 1, 2, 3), (2, 3, 0, 1))
    l2new_bbbb += einsum(x255, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    l2new_bbbb += einsum(x255, (0, 1, 2, 3), (2, 3, 1, 0)) * -1.0
    l2new_bbbb += einsum(x255, (0, 1, 2, 3), (3, 2, 1, 0))
    del x255
    x256 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x256 += einsum(f.bb.ov, (0, 1), t1.bb, (2, 1), (0, 2))
    x257 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x257 += einsum(x256, (0, 1), l2.bbbb, (2, 3, 4, 1), (0, 4, 2, 3))
    del x256
    x258 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x258 += einsum(l2.bbbb, (0, 1, 2, 3), x135, (2, 4, 3, 5), (4, 5, 0, 1))
    del x135
    x259 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x259 += einsum(t1.bb, (0, 1), x238, (2, 1), (2, 0))
    del x238
    x260 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x260 += einsum(x161, (0, 1), (0, 1))
    del x161
    x260 += einsum(x162, (0, 1), (1, 0))
    del x162
    x260 += einsum(x259, (0, 1), (1, 0))
    del x259
    x261 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x261 += einsum(x260, (0, 1), l2.bbbb, (2, 3, 4, 0), (1, 4, 2, 3)) * -2.0
    del x260
    x262 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x262 += einsum(x257, (0, 1, 2, 3), (0, 1, 3, 2)) * 2.0
    del x257
    x262 += einsum(x258, (0, 1, 2, 3), (0, 1, 3, 2)) * -2.0
    del x258
    x262 += einsum(x261, (0, 1, 2, 3), (1, 0, 3, 2))
    del x261
    l2new_bbbb += einsum(x262, (0, 1, 2, 3), (3, 2, 0, 1))
    l2new_bbbb += einsum(x262, (0, 1, 2, 3), (3, 2, 1, 0)) * -1.0
    del x262
    x263 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x263 += einsum(f.bb.oo, (0, 1), l2.bbbb, (2, 3, 4, 1), (0, 4, 2, 3))
    l2new_bbbb += einsum(x263, (0, 1, 2, 3), (3, 2, 0, 1)) * -2.0
    l2new_bbbb += einsum(x263, (0, 1, 2, 3), (3, 2, 1, 0)) * 2.0
    del x263
    x264 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x264 += einsum(x131, (0, 1, 2, 3), (3, 2, 1, 0))
    del x131
    x264 += einsum(x133, (0, 1, 2, 3), (0, 3, 1, 2))
    del x133
    x264 += einsum(x134, (0, 1, 2, 3), (0, 3, 1, 2))
    del x134
    l2new_bbbb += einsum(l2.bbbb, (0, 1, 2, 3), x264, (2, 4, 3, 5), (0, 1, 4, 5)) * -2.0
    del x264
    x265 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x265 += einsum(x140, (0, 1, 2, 3), (1, 0, 3, 2))
    del x140
    x265 += einsum(x139, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x139
    l2new_bbbb += einsum(x132, (0, 1, 2, 3), x265, (4, 5, 0, 1), (3, 2, 5, 4)) * 2.0
    del x132, x265

    l1new.aa = l1new_aa
    l1new.bb = l1new_bb
    l2new.aaaa = l2new_aaaa
    l2new.abab = l2new_abab
    l2new.bbbb = l2new_bbbb

    return {"l1new": l1new, "l2new": l2new}

def make_rdm1_f(f=None, v=None, nocc=None, nvir=None, naux=None, t1=None, t2=None, l1=None, l2=None, **kwargs):
    rdm1_f = Namespace()

    delta = Namespace(aa=Namespace(), bb=Namespace())
    delta.aa = Namespace(oo=np.eye(nocc[0]), vv=np.eye(nvir[0]))
    delta.bb = Namespace(oo=np.eye(nocc[1]), vv=np.eye(nvir[1]))

    # RDM1
    rdm1_f_aa_oo = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    rdm1_f_aa_oo += einsum(delta.aa.oo, (0, 1), (0, 1))
    rdm1_f_bb_oo = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    rdm1_f_bb_oo += einsum(delta.bb.oo, (0, 1), (0, 1))
    rdm1_f_aa_ov = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    rdm1_f_aa_ov += einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 0), (2, 3)) * 2.0
    rdm1_f_aa_ov += einsum(t1.aa, (0, 1), (0, 1))
    rdm1_f_aa_ov += einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    rdm1_f_bb_ov = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    rdm1_f_bb_ov += einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3)) * 2.0
    rdm1_f_bb_ov += einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    rdm1_f_bb_ov += einsum(t1.bb, (0, 1), (0, 1))
    rdm1_f_aa_vo = np.zeros((nvir[0], nocc[0]), dtype=types[float])
    rdm1_f_aa_vo += einsum(l1.aa, (0, 1), (0, 1))
    rdm1_f_bb_vo = np.zeros((nvir[1], nocc[1]), dtype=types[float])
    rdm1_f_bb_vo += einsum(l1.bb, (0, 1), (0, 1))
    rdm1_f_aa_vv = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    rdm1_f_aa_vv += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4)) * 2.0
    rdm1_f_aa_vv += einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    rdm1_f_aa_vv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    rdm1_f_bb_vv = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    rdm1_f_bb_vv += einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    rdm1_f_bb_vv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    rdm1_f_bb_vv += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4)) * 2.0
    x0 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x0 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    rdm1_f_aa_oo += einsum(x0, (0, 1), (1, 0)) * -1.0
    x1 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x1 += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    rdm1_f_aa_oo += einsum(x1, (0, 1), (1, 0)) * -2.0
    x2 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x2 += einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    rdm1_f_aa_oo += einsum(x2, (0, 1), (1, 0)) * -1.0
    x3 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x3 += einsum(l1.bb, (0, 1), t1.bb, (2, 0), (1, 2))
    rdm1_f_bb_oo += einsum(x3, (0, 1), (1, 0)) * -1.0
    x4 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x4 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    rdm1_f_bb_oo += einsum(x4, (0, 1), (1, 0)) * -1.0
    x5 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x5 += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    rdm1_f_bb_oo += einsum(x5, (0, 1), (1, 0)) * -2.0
    x6 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x6 += einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1_f_aa_ov += einsum(t2.aaaa, (0, 1, 2, 3), x6, (0, 1, 4, 3), (4, 2)) * 2.0
    del x6
    x7 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x7 += einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    rdm1_f_aa_ov += einsum(t2.abab, (0, 1, 2, 3), x7, (0, 4, 1, 3), (4, 2)) * -1.0
    del x7
    x8 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x8 += einsum(x2, (0, 1), (0, 1))
    del x2
    x8 += einsum(x1, (0, 1), (0, 1)) * 2.0
    del x1
    x8 += einsum(x0, (0, 1), (0, 1))
    del x0
    rdm1_f_aa_ov += einsum(t1.aa, (0, 1), x8, (0, 2), (2, 1)) * -1.0
    del x8
    x9 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x9 += einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1_f_bb_ov += einsum(t2.abab, (0, 1, 2, 3), x9, (0, 1, 4, 2), (4, 3)) * -1.0
    del x9
    x10 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x10 += einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm1_f_bb_ov += einsum(t2.bbbb, (0, 1, 2, 3), x10, (1, 0, 4, 3), (4, 2)) * -2.0
    del x10
    x11 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x11 += einsum(x3, (0, 1), (0, 1))
    del x3
    x11 += einsum(x4, (0, 1), (0, 1))
    del x4
    x11 += einsum(x5, (0, 1), (0, 1)) * 2.0
    del x5
    rdm1_f_bb_ov += einsum(t1.bb, (0, 1), x11, (0, 2), (2, 1)) * -1.0
    del x11

    rdm1_f_aa = np.block([[rdm1_f_aa_oo, rdm1_f_aa_ov], [rdm1_f_aa_vo, rdm1_f_aa_vv]])
    rdm1_f_bb = np.block([[rdm1_f_bb_oo, rdm1_f_bb_ov], [rdm1_f_bb_vo, rdm1_f_bb_vv]])

    rdm1_f.aa = rdm1_f_aa
    rdm1_f.bb = rdm1_f_bb

    return rdm1_f

def make_rdm2_f(f=None, v=None, nocc=None, nvir=None, naux=None, t1=None, t2=None, l1=None, l2=None, **kwargs):
    rdm2_f = Namespace()

    delta = Namespace(aa=Namespace(), bb=Namespace())
    delta.aa = Namespace(oo=np.eye(nocc[0]), vv=np.eye(nvir[0]))
    delta.bb = Namespace(oo=np.eye(nocc[1]), vv=np.eye(nvir[1]))

    # RDM2
    rdm2_f_aaaa_oooo = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    rdm2_f_aaaa_oooo += einsum(delta.aa.oo, (0, 1), delta.aa.oo, (2, 3), (0, 2, 1, 3))
    rdm2_f_aaaa_oooo += einsum(delta.aa.oo, (0, 1), delta.aa.oo, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_bbbb_oooo = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    rdm2_f_bbbb_oooo += einsum(delta.bb.oo, (0, 1), delta.bb.oo, (2, 3), (0, 2, 1, 3))
    rdm2_f_bbbb_oooo += einsum(delta.bb.oo, (0, 1), delta.bb.oo, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_aaaa_ovoo = np.zeros((nocc[0], nvir[0], nocc[0], nocc[0]), dtype=types[float])
    rdm2_f_aaaa_ovoo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 1, 3))
    rdm2_f_aaaa_ovoo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_abab_ovoo = np.zeros((nocc[0], nvir[1], nocc[0], nocc[1]), dtype=types[float])
    rdm2_f_abab_ovoo += einsum(delta.aa.oo, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2_f_bbbb_ovoo = np.zeros((nocc[1], nvir[1], nocc[1], nocc[1]), dtype=types[float])
    rdm2_f_bbbb_ovoo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (0, 2, 1, 3))
    rdm2_f_bbbb_ovoo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_aaaa_vooo = np.zeros((nvir[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    rdm2_f_aaaa_vooo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_aaaa_vooo += einsum(delta.aa.oo, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2_f_abab_vooo = np.zeros((nvir[0], nocc[1], nocc[0], nocc[1]), dtype=types[float])
    rdm2_f_abab_vooo += einsum(delta.bb.oo, (0, 1), l1.aa, (2, 3), (2, 0, 3, 1))
    rdm2_f_bbbb_vooo = np.zeros((nvir[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    rdm2_f_bbbb_vooo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_bbbb_vooo += einsum(delta.bb.oo, (0, 1), l1.bb, (2, 3), (2, 0, 3, 1))
    rdm2_f_aaaa_oovv = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    rdm2_f_aaaa_oovv += einsum(t2.aaaa, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    rdm2_f_aaaa_oovv += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_aaaa_oovv += einsum(t1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2_f_abab_oovv = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    rdm2_f_abab_oovv += einsum(t2.abab, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_bbbb_oovv = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    rdm2_f_bbbb_oovv += einsum(t2.bbbb, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    rdm2_f_aaaa_ovov = np.zeros((nocc[0], nvir[0], nocc[0], nvir[0]), dtype=types[float])
    rdm2_f_aaaa_ovov += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_bbbb_ovov = np.zeros((nocc[1], nvir[1], nocc[1], nvir[1]), dtype=types[float])
    rdm2_f_bbbb_ovov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_aaaa_ovvo = np.zeros((nocc[0], nvir[0], nvir[0], nocc[0]), dtype=types[float])
    rdm2_f_aaaa_ovvo += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2_f_abab_ovvo = np.zeros((nocc[0], nvir[1], nvir[0], nocc[1]), dtype=types[float])
    rdm2_f_abab_ovvo += einsum(l1.bb, (0, 1), t1.aa, (2, 3), (2, 0, 3, 1))
    rdm2_f_bbbb_ovvo = np.zeros((nocc[1], nvir[1], nvir[1], nocc[1]), dtype=types[float])
    rdm2_f_bbbb_ovvo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (2, 0, 3, 1))
    rdm2_f_aaaa_voov = np.zeros((nvir[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    rdm2_f_aaaa_voov += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 1, 3))
    rdm2_f_abab_voov = np.zeros((nvir[0], nocc[1], nocc[0], nvir[1]), dtype=types[float])
    rdm2_f_abab_voov += einsum(l1.aa, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2_f_bbbb_voov = np.zeros((nvir[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    rdm2_f_bbbb_voov += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    rdm2_f_aaaa_vovo = np.zeros((nvir[0], nocc[0], nvir[0], nocc[0]), dtype=types[float])
    rdm2_f_aaaa_vovo += einsum(l1.aa, (0, 1), t1.aa, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_bbbb_vovo = np.zeros((nvir[1], nocc[1], nvir[1], nocc[1]), dtype=types[float])
    rdm2_f_bbbb_vovo += einsum(l1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_aaaa_vvoo = np.zeros((nvir[0], nvir[0], nocc[0], nocc[0]), dtype=types[float])
    rdm2_f_aaaa_vvoo += einsum(l2.aaaa, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    rdm2_f_abab_vvoo = np.zeros((nvir[0], nvir[1], nocc[0], nocc[1]), dtype=types[float])
    rdm2_f_abab_vvoo += einsum(l2.abab, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_bbbb_vvoo = np.zeros((nvir[1], nvir[1], nocc[1], nocc[1]), dtype=types[float])
    rdm2_f_bbbb_vvoo += einsum(l2.bbbb, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    rdm2_f_abab_ovvv = np.zeros((nocc[0], nvir[1], nvir[0], nvir[1]), dtype=types[float])
    rdm2_f_abab_ovvv += einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2_f_abab_vovv = np.zeros((nvir[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    rdm2_f_abab_vovv += einsum(l1.aa, (0, 1), t2.abab, (1, 2, 3, 4), (0, 2, 3, 4))
    rdm2_f_abab_vvvo = np.zeros((nvir[0], nvir[1], nvir[0], nocc[1]), dtype=types[float])
    rdm2_f_abab_vvvo += einsum(t1.aa, (0, 1), l2.abab, (2, 3, 0, 4), (2, 3, 1, 4))
    rdm2_f_aaaa_vvvv = np.zeros((nvir[0], nvir[0], nvir[0], nvir[0]), dtype=types[float])
    rdm2_f_aaaa_vvvv += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 5), (0, 1, 4, 5)) * 2.0
    rdm2_f_abab_vvvv = np.zeros((nvir[0], nvir[1], nvir[0], nvir[1]), dtype=types[float])
    rdm2_f_abab_vvvv += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2_f_bbbb_vvvv = np.zeros((nvir[1], nvir[1], nvir[1], nvir[1]), dtype=types[float])
    rdm2_f_bbbb_vvvv += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 5), (0, 1, 4, 5)) * 2.0
    x0 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x0 += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 5, 0, 1), (2, 3, 4, 5))
    rdm2_f_aaaa_oooo += einsum(x0, (0, 1, 2, 3), (3, 2, 1, 0)) * 2.0
    x1 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x1 += einsum(t1.aa, (0, 1), l2.aaaa, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2_f_aaaa_ovoo += einsum(x1, (0, 1, 2, 3), (2, 3, 1, 0)) * -2.0
    rdm2_f_aaaa_vooo += einsum(x1, (0, 1, 2, 3), (3, 2, 1, 0)) * 2.0
    x2 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x2 += einsum(t1.aa, (0, 1), x1, (2, 3, 4, 1), (2, 3, 0, 4))
    rdm2_f_aaaa_oooo += einsum(x2, (0, 1, 2, 3), (2, 3, 1, 0)) * -2.0
    x3 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x3 += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 0, 1), (2, 4))
    x4 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x4 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 1), (2, 4))
    x5 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x5 += einsum(x3, (0, 1), (0, 1))
    x5 += einsum(x4, (0, 1), (0, 1)) * 0.5
    rdm2_f_aaaa_oooo += einsum(delta.aa.oo, (0, 1), x5, (2, 3), (0, 3, 1, 2)) * -2.0
    rdm2_f_aaaa_oooo += einsum(delta.aa.oo, (0, 1), x5, (2, 3), (0, 3, 2, 1)) * 2.0
    rdm2_f_aaaa_oooo += einsum(delta.aa.oo, (0, 1), x5, (2, 3), (3, 0, 1, 2)) * 2.0
    rdm2_f_aaaa_oooo += einsum(delta.aa.oo, (0, 1), x5, (2, 3), (3, 0, 2, 1)) * -2.0
    x6 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x6 += einsum(l1.aa, (0, 1), t1.aa, (2, 0), (1, 2))
    rdm2_f_aaaa_oooo += einsum(delta.aa.oo, (0, 1), x6, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_aaaa_oooo += einsum(delta.aa.oo, (0, 1), x6, (2, 3), (3, 0, 1, 2))
    rdm2_f_aaaa_oooo += einsum(delta.aa.oo, (0, 1), x6, (2, 3), (0, 3, 2, 1))
    rdm2_f_aaaa_oooo += einsum(delta.aa.oo, (0, 1), x6, (2, 3), (3, 0, 2, 1)) * -1.0
    x7 = np.zeros((nocc[0], nocc[0], nocc[1], nocc[1]), dtype=types[float])
    x7 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 5, 0, 1), (2, 4, 3, 5))
    rdm2_f_abab_oooo = np.zeros((nocc[0], nocc[1], nocc[0], nocc[1]), dtype=types[float])
    rdm2_f_abab_oooo += einsum(x7, (0, 1, 2, 3), (1, 3, 0, 2))
    x8 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x8 += einsum(t1.bb, (0, 1), l2.abab, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2_f_abab_vooo += einsum(x8, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_abab_vovo = np.zeros((nvir[0], nocc[1], nvir[0], nocc[1]), dtype=types[float])
    rdm2_f_abab_vovo += einsum(t1.aa, (0, 1), x8, (0, 2, 3, 4), (4, 3, 1, 2)) * -1.0
    rdm2_f_abab_vovv += einsum(t2.abab, (0, 1, 2, 3), x8, (0, 1, 4, 5), (5, 4, 2, 3)) * -1.0
    x9 = np.zeros((nocc[0], nocc[0], nocc[1], nocc[1]), dtype=types[float])
    x9 += einsum(t1.aa, (0, 1), x8, (2, 3, 4, 1), (2, 0, 3, 4))
    rdm2_f_abab_oooo += einsum(x9, (0, 1, 2, 3), (1, 3, 0, 2))
    x10 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x10 += einsum(delta.aa.oo, (0, 1), (0, 1)) * -1.0
    x10 += einsum(x6, (0, 1), (0, 1))
    x10 += einsum(x3, (0, 1), (0, 1)) * 2.0
    x10 += einsum(x4, (0, 1), (0, 1))
    rdm2_f_abab_oooo += einsum(delta.bb.oo, (0, 1), x10, (2, 3), (3, 0, 2, 1)) * -1.0
    del x10
    x11 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x11 += einsum(l1.bb, (0, 1), t1.bb, (2, 0), (1, 2))
    rdm2_f_bbbb_oooo += einsum(delta.bb.oo, (0, 1), x11, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_bbbb_oooo += einsum(delta.bb.oo, (0, 1), x11, (2, 3), (3, 0, 1, 2))
    rdm2_f_bbbb_oooo += einsum(delta.bb.oo, (0, 1), x11, (2, 3), (0, 3, 2, 1))
    rdm2_f_bbbb_oooo += einsum(delta.bb.oo, (0, 1), x11, (2, 3), (3, 0, 2, 1)) * -1.0
    x12 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x12 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 1), (3, 4))
    x13 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x13 += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 0, 1), (2, 4))
    x14 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x14 += einsum(x11, (0, 1), (0, 1))
    x14 += einsum(x12, (0, 1), (0, 1))
    x14 += einsum(x13, (0, 1), (0, 1)) * 2.0
    rdm2_f_abab_oooo += einsum(delta.aa.oo, (0, 1), x14, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_abab_oovv += einsum(x14, (0, 1), t2.abab, (2, 0, 3, 4), (2, 1, 3, 4)) * -1.0
    del x14
    x15 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x15 += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 5, 0, 1), (2, 3, 4, 5))
    rdm2_f_bbbb_oooo += einsum(x15, (0, 1, 2, 3), (3, 2, 1, 0)) * 2.0
    x16 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x16 += einsum(t1.bb, (0, 1), l2.bbbb, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2_f_bbbb_ovoo += einsum(x16, (0, 1, 2, 3), (2, 3, 1, 0)) * -2.0
    rdm2_f_bbbb_vooo += einsum(x16, (0, 1, 2, 3), (3, 2, 1, 0)) * 2.0
    x17 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x17 += einsum(t1.bb, (0, 1), x16, (2, 3, 4, 1), (2, 3, 0, 4))
    rdm2_f_bbbb_oooo += einsum(x17, (0, 1, 2, 3), (2, 3, 1, 0)) * -2.0
    x18 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x18 += einsum(x12, (0, 1), (0, 1))
    x18 += einsum(x13, (0, 1), (0, 1)) * 2.0
    rdm2_f_bbbb_oooo += einsum(delta.bb.oo, (0, 1), x18, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_bbbb_oooo += einsum(delta.bb.oo, (0, 1), x18, (2, 3), (0, 3, 2, 1))
    rdm2_f_bbbb_oooo += einsum(delta.bb.oo, (0, 1), x18, (2, 3), (3, 0, 1, 2))
    rdm2_f_bbbb_oooo += einsum(delta.bb.oo, (0, 1), x18, (2, 3), (3, 0, 2, 1)) * -1.0
    x19 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x19 += einsum(l1.aa, (0, 1), t2.aaaa, (2, 3, 4, 0), (1, 2, 3, 4))
    rdm2_f_aaaa_ooov = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    rdm2_f_aaaa_ooov += einsum(x19, (0, 1, 2, 3), (2, 1, 0, 3)) * -2.0
    rdm2_f_aaaa_oovo = np.zeros((nocc[0], nocc[0], nvir[0], nocc[0]), dtype=types[float])
    rdm2_f_aaaa_oovo += einsum(x19, (0, 1, 2, 3), (2, 1, 3, 0)) * 2.0
    x20 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x20 += einsum(t2.aaaa, (0, 1, 2, 3), x1, (4, 1, 5, 3), (4, 5, 0, 2)) * -1.0
    x21 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x21 += einsum(t1.aa, (0, 1), l2.abab, (1, 2, 3, 4), (3, 0, 4, 2))
    rdm2_f_abab_ovoo += einsum(x21, (0, 1, 2, 3), (1, 3, 0, 2)) * -1.0
    rdm2_f_abab_ovov = np.zeros((nocc[0], nvir[1], nocc[0], nvir[1]), dtype=types[float])
    rdm2_f_abab_ovov += einsum(t1.bb, (0, 1), x21, (2, 3, 0, 4), (3, 4, 2, 1)) * -1.0
    rdm2_f_abab_ovvv += einsum(t2.abab, (0, 1, 2, 3), x21, (0, 4, 1, 5), (4, 5, 2, 3)) * -1.0
    x22 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x22 += einsum(t2.abab, (0, 1, 2, 3), x21, (4, 5, 1, 3), (4, 5, 0, 2))
    x23 = np.zeros((nocc[0], nocc[0]), dtype=types[float])
    x23 += einsum(x6, (0, 1), (0, 1))
    x23 += einsum(x3, (0, 1), (0, 1)) * 2.0
    del x3
    x23 += einsum(x4, (0, 1), (0, 1))
    del x4
    rdm2_f_abab_ooov = np.zeros((nocc[0], nocc[1], nocc[0], nvir[1]), dtype=types[float])
    rdm2_f_abab_ooov += einsum(t1.bb, (0, 1), x23, (2, 3), (3, 0, 2, 1)) * -1.0
    rdm2_f_abab_oovv += einsum(x23, (0, 1), t2.abab, (0, 2, 3, 4), (1, 2, 3, 4)) * -1.0
    x24 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x24 += einsum(delta.aa.oo, (0, 1), t1.aa, (2, 3), (0, 1, 2, 3))
    x24 += einsum(x20, (0, 1, 2, 3), (1, 0, 2, 3)) * -4.0
    x24 += einsum(x22, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x24 += einsum(t1.aa, (0, 1), x23, (2, 3), (0, 2, 3, 1))
    rdm2_f_aaaa_ooov += einsum(x24, (0, 1, 2, 3), (0, 2, 1, 3))
    rdm2_f_aaaa_ooov += einsum(x24, (0, 1, 2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_aaaa_oovo += einsum(x24, (0, 1, 2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_aaaa_oovo += einsum(x24, (0, 1, 2, 3), (2, 0, 3, 1))
    del x24
    x25 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x25 += einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 0), (2, 3))
    x26 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x26 += einsum(l1.bb, (0, 1), t2.abab, (2, 1, 3, 0), (2, 3))
    x27 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x27 += einsum(t2.aaaa, (0, 1, 2, 3), x1, (0, 1, 4, 3), (4, 2)) * -1.0
    x28 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x28 += einsum(t2.abab, (0, 1, 2, 3), x21, (0, 4, 1, 3), (4, 2))
    x29 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x29 += einsum(t1.aa, (0, 1), x23, (0, 2), (2, 1)) * 0.5
    x30 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x30 += einsum(x25, (0, 1), (0, 1)) * -1.0
    x30 += einsum(x26, (0, 1), (0, 1)) * -0.5
    x30 += einsum(x27, (0, 1), (0, 1))
    x30 += einsum(x28, (0, 1), (0, 1)) * 0.5
    x30 += einsum(x29, (0, 1), (0, 1))
    rdm2_f_aaaa_ooov += einsum(delta.aa.oo, (0, 1), x30, (2, 3), (0, 2, 1, 3)) * -2.0
    rdm2_f_aaaa_ooov += einsum(delta.aa.oo, (0, 1), x30, (2, 3), (2, 0, 1, 3)) * 2.0
    rdm2_f_aaaa_oovo += einsum(delta.aa.oo, (0, 1), x30, (2, 3), (0, 2, 3, 1)) * 2.0
    rdm2_f_aaaa_oovo += einsum(delta.aa.oo, (0, 1), x30, (2, 3), (2, 0, 3, 1)) * -2.0
    x31 = np.zeros((nocc[0], nocc[0], nocc[0], nocc[0]), dtype=types[float])
    x31 += einsum(x0, (0, 1, 2, 3), (1, 0, 3, 2))
    del x0
    x31 += einsum(x2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x2
    rdm2_f_aaaa_oovv += einsum(t2.aaaa, (0, 1, 2, 3), x31, (0, 1, 4, 5), (5, 4, 2, 3)) * -2.0
    x32 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x32 += einsum(t1.aa, (0, 1), x31, (0, 2, 3, 4), (2, 3, 4, 1)) * 2.0
    rdm2_f_aaaa_ooov += einsum(x32, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_aaaa_oovo += einsum(x32, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    del x32
    x33 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x33 += einsum(t2.abab, (0, 1, 2, 3), x1, (4, 0, 5, 2), (4, 5, 1, 3)) * -1.0
    rdm2_f_abab_ooov += einsum(x33, (0, 1, 2, 3), (1, 2, 0, 3)) * -2.0
    x34 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x34 += einsum(l1.aa, (0, 1), t2.abab, (2, 3, 0, 4), (1, 2, 3, 4))
    rdm2_f_abab_ooov += einsum(x34, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    x35 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x35 += einsum(t2.abab, (0, 1, 2, 3), x8, (4, 1, 5, 2), (4, 0, 5, 3))
    rdm2_f_abab_ooov += einsum(x35, (0, 1, 2, 3), (1, 2, 0, 3))
    x36 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x36 += einsum(t2.bbbb, (0, 1, 2, 3), x21, (4, 5, 1, 3), (4, 5, 0, 2))
    rdm2_f_abab_ooov += einsum(x36, (0, 1, 2, 3), (1, 2, 0, 3)) * -2.0
    x37 = np.zeros((nocc[0], nocc[0], nocc[1], nocc[1]), dtype=types[float])
    x37 += einsum(x7, (0, 1, 2, 3), (0, 1, 2, 3))
    del x7
    x37 += einsum(x9, (0, 1, 2, 3), (0, 1, 2, 3))
    del x9
    rdm2_f_abab_ooov += einsum(t1.bb, (0, 1), x37, (2, 3, 0, 4), (3, 4, 2, 1))
    rdm2_f_abab_oovo = np.zeros((nocc[0], nocc[1], nvir[0], nocc[1]), dtype=types[float])
    rdm2_f_abab_oovo += einsum(t1.aa, (0, 1), x37, (0, 2, 3, 4), (2, 4, 1, 3))
    rdm2_f_abab_oovv += einsum(t2.abab, (0, 1, 2, 3), x37, (0, 4, 1, 5), (4, 5, 2, 3))
    x38 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x38 += einsum(l1.aa, (0, 1), t2.abab, (1, 2, 0, 3), (2, 3))
    x39 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x39 += einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 0), (2, 3))
    x40 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x40 += einsum(t2.abab, (0, 1, 2, 3), x8, (0, 1, 4, 2), (4, 3))
    x41 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x41 += einsum(t2.bbbb, (0, 1, 2, 3), x16, (0, 1, 4, 3), (4, 2)) * -1.0
    x42 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x42 += einsum(x11, (0, 1), (0, 1)) * 0.5
    x42 += einsum(x12, (0, 1), (0, 1)) * 0.5
    x42 += einsum(x13, (0, 1), (0, 1))
    x43 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x43 += einsum(t1.bb, (0, 1), x42, (0, 2), (2, 1)) * 2.0
    x44 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x44 += einsum(t1.bb, (0, 1), (0, 1)) * -1.0
    x44 += einsum(x38, (0, 1), (0, 1)) * -1.0
    x44 += einsum(x39, (0, 1), (0, 1)) * -2.0
    x44 += einsum(x40, (0, 1), (0, 1))
    x44 += einsum(x41, (0, 1), (0, 1)) * 2.0
    x44 += einsum(x43, (0, 1), (0, 1))
    rdm2_f_abab_ooov += einsum(delta.aa.oo, (0, 1), x44, (2, 3), (0, 2, 1, 3)) * -1.0
    del x44
    x45 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x45 += einsum(l1.bb, (0, 1), t2.bbbb, (2, 3, 4, 0), (1, 2, 3, 4))
    rdm2_f_bbbb_ooov = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    rdm2_f_bbbb_ooov += einsum(x45, (0, 1, 2, 3), (2, 1, 0, 3)) * -2.0
    rdm2_f_bbbb_oovo = np.zeros((nocc[1], nocc[1], nvir[1], nocc[1]), dtype=types[float])
    rdm2_f_bbbb_oovo += einsum(x45, (0, 1, 2, 3), (2, 1, 3, 0)) * 2.0
    x46 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x46 += einsum(t2.abab, (0, 1, 2, 3), x8, (0, 4, 5, 2), (4, 5, 1, 3))
    x47 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x47 += einsum(t2.bbbb, (0, 1, 2, 3), x16, (4, 1, 5, 3), (4, 5, 0, 2)) * -1.0
    x48 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x48 += einsum(delta.bb.oo, (0, 1), t1.bb, (2, 3), (0, 1, 2, 3))
    x48 += einsum(x46, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x48 += einsum(x47, (0, 1, 2, 3), (1, 0, 2, 3)) * -4.0
    x48 += einsum(t1.bb, (0, 1), x42, (2, 3), (0, 2, 3, 1)) * 2.0
    rdm2_f_bbbb_ooov += einsum(x48, (0, 1, 2, 3), (0, 2, 1, 3))
    rdm2_f_bbbb_ooov += einsum(x48, (0, 1, 2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_bbbb_oovo += einsum(x48, (0, 1, 2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_bbbb_oovo += einsum(x48, (0, 1, 2, 3), (2, 0, 3, 1))
    del x48
    x49 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x49 += einsum(x38, (0, 1), (0, 1)) * -1.0
    x49 += einsum(x39, (0, 1), (0, 1)) * -2.0
    x49 += einsum(x40, (0, 1), (0, 1))
    x49 += einsum(x41, (0, 1), (0, 1)) * 2.0
    x49 += einsum(x43, (0, 1), (0, 1))
    del x43
    rdm2_f_bbbb_ooov += einsum(delta.bb.oo, (0, 1), x49, (2, 3), (0, 2, 1, 3)) * -1.0
    rdm2_f_bbbb_ooov += einsum(delta.bb.oo, (0, 1), x49, (2, 3), (2, 0, 1, 3))
    rdm2_f_bbbb_oovo += einsum(delta.bb.oo, (0, 1), x49, (2, 3), (0, 2, 3, 1))
    rdm2_f_bbbb_oovo += einsum(delta.bb.oo, (0, 1), x49, (2, 3), (2, 0, 3, 1)) * -1.0
    x50 = np.zeros((nocc[1], nocc[1], nocc[1], nocc[1]), dtype=types[float])
    x50 += einsum(x15, (0, 1, 2, 3), (1, 0, 3, 2))
    del x15
    x50 += einsum(x17, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x17
    rdm2_f_bbbb_oovv += einsum(t2.bbbb, (0, 1, 2, 3), x50, (0, 1, 4, 5), (5, 4, 2, 3)) * -2.0
    x51 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x51 += einsum(t1.bb, (0, 1), x50, (0, 2, 3, 4), (2, 3, 4, 1)) * 2.0
    rdm2_f_bbbb_ooov += einsum(x51, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_bbbb_oovo += einsum(x51, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    del x51
    x52 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x52 += einsum(l1.bb, (0, 1), t2.abab, (2, 3, 4, 0), (2, 1, 3, 4))
    rdm2_f_abab_oovo += einsum(x52, (0, 1, 2, 3), (0, 2, 3, 1)) * -1.0
    x53 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x53 += einsum(t2.abab, (0, 1, 2, 3), x16, (4, 1, 5, 3), (0, 4, 5, 2)) * -1.0
    rdm2_f_abab_oovo += einsum(x53, (0, 1, 2, 3), (0, 2, 3, 1)) * -2.0
    x54 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x54 += einsum(t2.abab, (0, 1, 2, 3), x21, (0, 4, 5, 3), (4, 5, 1, 2))
    rdm2_f_abab_oovo += einsum(x54, (0, 1, 2, 3), (0, 2, 3, 1))
    x55 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x55 += einsum(t2.aaaa, (0, 1, 2, 3), x8, (1, 4, 5, 3), (0, 4, 5, 2))
    rdm2_f_abab_oovo += einsum(x55, (0, 1, 2, 3), (0, 2, 3, 1)) * -2.0
    x56 = np.zeros((nocc[1], nocc[1]), dtype=types[float])
    x56 += einsum(delta.bb.oo, (0, 1), (0, 1)) * -1.0
    x56 += einsum(x11, (0, 1), (0, 1))
    x56 += einsum(x12, (0, 1), (0, 1))
    del x12
    x56 += einsum(x13, (0, 1), (0, 1)) * 2.0
    del x13
    rdm2_f_abab_oovo += einsum(t1.aa, (0, 1), x56, (2, 3), (0, 3, 1, 2)) * -1.0
    del x56
    x57 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x57 += einsum(x25, (0, 1), (0, 1)) * -2.0
    x57 += einsum(x26, (0, 1), (0, 1)) * -1.0
    x57 += einsum(x27, (0, 1), (0, 1)) * 2.0
    x57 += einsum(x28, (0, 1), (0, 1))
    x57 += einsum(t1.aa, (0, 1), x23, (0, 2), (2, 1))
    del x23
    rdm2_f_abab_oovo += einsum(delta.bb.oo, (0, 1), x57, (2, 3), (2, 0, 3, 1)) * -1.0
    del x57
    x58 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x58 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2_f_aaaa_ovov += einsum(x58, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_aaaa_ovvo += einsum(x58, (0, 1, 2, 3), (1, 2, 3, 0))
    rdm2_f_aaaa_voov += einsum(x58, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_aaaa_vovo += einsum(x58, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    x59 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x59 += einsum(t2.aaaa, (0, 1, 2, 3), x58, (1, 4, 3, 5), (0, 4, 2, 5))
    x60 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x60 += einsum(x20, (0, 1, 2, 3), (0, 1, 2, 3))
    del x20
    x60 += einsum(x22, (0, 1, 2, 3), (0, 1, 2, 3)) * 0.25
    del x22
    x61 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x61 += einsum(t1.aa, (0, 1), x60, (0, 2, 3, 4), (2, 3, 1, 4)) * 4.0
    del x60
    x62 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x62 += einsum(x59, (0, 1, 2, 3), (0, 1, 2, 3)) * -2.0
    del x59
    x62 += einsum(x61, (0, 1, 2, 3), (0, 1, 2, 3))
    del x61
    x62 += einsum(t1.aa, (0, 1), x30, (2, 3), (0, 2, 1, 3)) * 2.0
    del x30
    rdm2_f_aaaa_oovv += einsum(x62, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    rdm2_f_aaaa_oovv += einsum(x62, (0, 1, 2, 3), (0, 1, 3, 2))
    rdm2_f_aaaa_oovv += einsum(x62, (0, 1, 2, 3), (1, 0, 2, 3))
    rdm2_f_aaaa_oovv += einsum(x62, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x62
    x63 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x63 += einsum(x6, (0, 1), t2.aaaa, (2, 0, 3, 4), (1, 2, 3, 4))
    del x6
    x64 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x64 += einsum(x5, (0, 1), t2.aaaa, (2, 0, 3, 4), (2, 1, 3, 4)) * -4.0
    del x5
    x65 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x65 += einsum(x63, (0, 1, 2, 3), (0, 1, 3, 2)) * 2.0
    del x63
    x65 += einsum(x64, (0, 1, 2, 3), (0, 1, 3, 2))
    del x64
    rdm2_f_aaaa_oovv += einsum(x65, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    rdm2_f_aaaa_oovv += einsum(x65, (0, 1, 2, 3), (1, 0, 2, 3))
    del x65
    x66 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x66 += einsum(t1.aa, (0, 1), x19, (0, 2, 3, 4), (2, 3, 1, 4))
    del x19
    x67 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x67 += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2_f_aaaa_ovov += einsum(x67, (0, 1, 2, 3), (1, 2, 0, 3)) * -4.0
    rdm2_f_aaaa_ovvo += einsum(x67, (0, 1, 2, 3), (1, 2, 3, 0)) * 4.0
    rdm2_f_aaaa_voov += einsum(x67, (0, 1, 2, 3), (2, 1, 0, 3)) * 4.0
    rdm2_f_aaaa_vovo += einsum(x67, (0, 1, 2, 3), (2, 1, 3, 0)) * -4.0
    x68 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x68 += einsum(t2.aaaa, (0, 1, 2, 3), x67, (1, 4, 3, 5), (0, 4, 2, 5))
    x69 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x69 += einsum(l2.bbbb, (0, 1, 2, 3), t2.abab, (4, 3, 5, 1), (4, 2, 5, 0))
    rdm2_f_abab_ovvo += einsum(x69, (0, 1, 2, 3), (0, 3, 2, 1)) * 2.0
    x70 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x70 += einsum(t2.abab, (0, 1, 2, 3), x69, (4, 1, 5, 3), (4, 0, 5, 2))
    x71 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x71 += einsum(l2.aaaa, (0, 1, 2, 3), t2.aaaa, (2, 3, 4, 1), (0, 4))
    x72 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x72 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 4, 1), (0, 4))
    x73 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x73 += einsum(x71, (0, 1), (0, 1))
    x73 += einsum(x72, (0, 1), (0, 1)) * 0.5
    rdm2_f_abab_oovv += einsum(x73, (0, 1), t2.abab, (2, 3, 0, 4), (2, 3, 1, 4)) * -2.0
    x74 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x74 += einsum(x73, (0, 1), t2.aaaa, (2, 3, 4, 0), (2, 3, 4, 1)) * -4.0
    del x73
    x75 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x75 += einsum(x66, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x66
    x75 += einsum(x68, (0, 1, 2, 3), (0, 1, 2, 3)) * 8.0
    del x68
    x75 += einsum(x70, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x70
    x75 += einsum(x74, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x74
    rdm2_f_aaaa_oovv += einsum(x75, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_aaaa_oovv += einsum(x75, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x75
    x76 = np.zeros((nocc[0], nocc[0], nocc[0], nvir[0]), dtype=types[float])
    x76 += einsum(t1.aa, (0, 1), x31, (0, 2, 3, 4), (2, 4, 3, 1))
    del x31
    rdm2_f_aaaa_oovv += einsum(t1.aa, (0, 1), x76, (0, 2, 3, 4), (2, 3, 4, 1)) * -2.0
    del x76
    x77 = np.zeros((nocc[1], nocc[1], nvir[0], nvir[0]), dtype=types[float])
    x77 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 5, 1), (3, 4, 0, 5))
    rdm2_f_abab_oovv += einsum(t2.abab, (0, 1, 2, 3), x77, (1, 4, 2, 5), (0, 4, 5, 3))
    rdm2_f_abab_vovo += einsum(x77, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    rdm2_f_abab_vovv += einsum(t1.bb, (0, 1), x77, (0, 2, 3, 4), (3, 2, 4, 1)) * -1.0
    del x77
    x78 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x78 += einsum(x67, (0, 1, 2, 3), (0, 1, 2, 3))
    del x67
    x78 += einsum(x58, (0, 1, 2, 3), (0, 1, 2, 3)) * 0.25
    del x58
    rdm2_f_abab_oovv += einsum(t2.abab, (0, 1, 2, 3), x78, (0, 4, 2, 5), (4, 1, 5, 3)) * 4.0
    x79 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x79 += einsum(l2.abab, (0, 1, 2, 3), t2.aaaa, (4, 2, 5, 0), (4, 3, 5, 1))
    rdm2_f_abab_ovvo += einsum(x79, (0, 1, 2, 3), (0, 3, 2, 1)) * 2.0
    x80 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x80 += einsum(x79, (0, 1, 2, 3), (0, 1, 2, 3))
    x80 += einsum(x69, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_abab_oovv += einsum(t2.bbbb, (0, 1, 2, 3), x80, (4, 1, 5, 3), (4, 0, 5, 2)) * 4.0
    del x80
    x81 = np.zeros((nocc[0], nocc[0], nocc[1], nvir[1]), dtype=types[float])
    x81 += einsum(x34, (0, 1, 2, 3), (0, 1, 2, 3)) * 0.5
    del x34
    x81 += einsum(x33, (0, 1, 2, 3), (0, 1, 2, 3))
    del x33
    x81 += einsum(x36, (0, 1, 2, 3), (0, 1, 2, 3))
    del x36
    x81 += einsum(x35, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    del x35
    x81 += einsum(t1.bb, (0, 1), x37, (2, 3, 0, 4), (2, 3, 4, 1)) * -0.5
    del x37
    rdm2_f_abab_oovv += einsum(t1.aa, (0, 1), x81, (0, 2, 3, 4), (2, 3, 1, 4)) * -2.0
    del x81
    x82 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x82 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 3, 0, 4), (1, 4))
    x83 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x83 += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (2, 3, 4, 1), (0, 4))
    x84 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x84 += einsum(x82, (0, 1), (0, 1)) * 0.5
    x84 += einsum(x83, (0, 1), (0, 1))
    rdm2_f_abab_oovv += einsum(x84, (0, 1), t2.abab, (2, 3, 4, 0), (2, 3, 4, 1)) * -2.0
    del x84
    x85 = np.zeros((nocc[0], nocc[1], nocc[1], nvir[0]), dtype=types[float])
    x85 += einsum(x52, (0, 1, 2, 3), (0, 1, 2, 3))
    del x52
    x85 += einsum(x55, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x55
    x85 += einsum(x54, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x54
    x85 += einsum(x53, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x53
    rdm2_f_abab_oovv += einsum(t1.bb, (0, 1), x85, (2, 0, 3, 4), (2, 3, 4, 1)) * -1.0
    del x85
    x86 = np.zeros((nocc[0], nvir[0]), dtype=types[float])
    x86 += einsum(t1.aa, (0, 1), (0, 1)) * -0.5
    x86 += einsum(x25, (0, 1), (0, 1)) * -1.0
    del x25
    x86 += einsum(x26, (0, 1), (0, 1)) * -0.5
    del x26
    x86 += einsum(x27, (0, 1), (0, 1))
    del x27
    x86 += einsum(x28, (0, 1), (0, 1)) * 0.5
    del x28
    x86 += einsum(x29, (0, 1), (0, 1))
    del x29
    rdm2_f_abab_oovv += einsum(t1.bb, (0, 1), x86, (2, 3), (2, 0, 3, 1)) * -2.0
    del x86
    x87 = np.zeros((nocc[1], nvir[1]), dtype=types[float])
    x87 += einsum(x38, (0, 1), (0, 1)) * -0.5
    del x38
    x87 += einsum(x39, (0, 1), (0, 1)) * -1.0
    del x39
    x87 += einsum(x40, (0, 1), (0, 1)) * 0.5
    del x40
    x87 += einsum(x41, (0, 1), (0, 1))
    del x41
    x87 += einsum(t1.bb, (0, 1), x42, (0, 2), (2, 1))
    del x42
    rdm2_f_abab_oovv += einsum(t1.aa, (0, 1), x87, (2, 3), (0, 2, 1, 3)) * -2.0
    del x87
    x88 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x88 += einsum(l2.aaaa, (0, 1, 2, 3), t2.abab, (3, 4, 1, 5), (2, 4, 0, 5))
    rdm2_f_abab_voov += einsum(x88, (0, 1, 2, 3), (2, 1, 0, 3)) * 2.0
    x89 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x89 += einsum(t2.abab, (0, 1, 2, 3), x88, (0, 4, 2, 5), (4, 1, 5, 3))
    x90 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x90 += einsum(t1.bb, (0, 1), t1.bb, (2, 3), (0, 2, 1, 3))
    x90 += einsum(x89, (0, 1, 2, 3), (1, 0, 3, 2)) * 2.0
    del x89
    rdm2_f_bbbb_oovv += einsum(x90, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_bbbb_oovv += einsum(x90, (0, 1, 2, 3), (0, 1, 2, 3))
    del x90
    x91 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x91 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (2, 4, 0, 5), (3, 4, 1, 5))
    rdm2_f_bbbb_ovov += einsum(x91, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_bbbb_ovvo += einsum(x91, (0, 1, 2, 3), (1, 2, 3, 0))
    rdm2_f_bbbb_voov += einsum(x91, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_bbbb_vovo += einsum(x91, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    x92 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x92 += einsum(t2.bbbb, (0, 1, 2, 3), x91, (1, 4, 3, 5), (4, 0, 5, 2))
    x93 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x93 += einsum(x46, (0, 1, 2, 3), (0, 1, 2, 3))
    del x46
    x93 += einsum(x47, (0, 1, 2, 3), (0, 1, 2, 3)) * 4.0
    del x47
    x94 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x94 += einsum(t1.bb, (0, 1), x93, (0, 2, 3, 4), (2, 3, 1, 4))
    del x93
    x95 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x95 += einsum(x92, (0, 1, 2, 3), (0, 1, 2, 3)) * -2.0
    del x92
    x95 += einsum(x94, (0, 1, 2, 3), (0, 1, 2, 3))
    del x94
    x95 += einsum(t1.bb, (0, 1), x49, (2, 3), (0, 2, 1, 3))
    del x49
    rdm2_f_bbbb_oovv += einsum(x95, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    rdm2_f_bbbb_oovv += einsum(x95, (0, 1, 2, 3), (0, 1, 3, 2))
    rdm2_f_bbbb_oovv += einsum(x95, (0, 1, 2, 3), (1, 0, 2, 3))
    rdm2_f_bbbb_oovv += einsum(x95, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x95
    x96 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x96 += einsum(x11, (0, 1), t2.bbbb, (2, 0, 3, 4), (1, 2, 3, 4))
    del x11
    x97 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x97 += einsum(x18, (0, 1), t2.bbbb, (2, 0, 3, 4), (2, 1, 3, 4)) * -2.0
    del x18
    x98 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x98 += einsum(x96, (0, 1, 2, 3), (0, 1, 3, 2)) * 2.0
    del x96
    x98 += einsum(x97, (0, 1, 2, 3), (0, 1, 3, 2))
    del x97
    rdm2_f_bbbb_oovv += einsum(x98, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    rdm2_f_bbbb_oovv += einsum(x98, (0, 1, 2, 3), (1, 0, 2, 3))
    del x98
    x99 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x99 += einsum(t1.bb, (0, 1), x45, (0, 2, 3, 4), (2, 3, 1, 4))
    del x45
    x100 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x100 += einsum(l2.bbbb, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2_f_bbbb_ovov += einsum(x100, (0, 1, 2, 3), (1, 2, 0, 3)) * -4.0
    rdm2_f_bbbb_ovvo += einsum(x100, (0, 1, 2, 3), (1, 2, 3, 0)) * 4.0
    rdm2_f_bbbb_voov += einsum(x100, (0, 1, 2, 3), (2, 1, 0, 3)) * 4.0
    rdm2_f_bbbb_vovo += einsum(x100, (0, 1, 2, 3), (2, 1, 3, 0)) * -4.0
    x101 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x101 += einsum(t2.bbbb, (0, 1, 2, 3), x100, (1, 4, 3, 5), (0, 4, 2, 5))
    x102 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x102 += einsum(x82, (0, 1), (0, 1))
    x102 += einsum(x83, (0, 1), (0, 1)) * 2.0
    x103 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x103 += einsum(x102, (0, 1), t2.bbbb, (2, 3, 4, 0), (2, 3, 4, 1)) * -2.0
    del x102
    x104 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x104 += einsum(x99, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x99
    x104 += einsum(x101, (0, 1, 2, 3), (0, 1, 2, 3)) * 8.0
    del x101
    x104 += einsum(x103, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x103
    rdm2_f_bbbb_oovv += einsum(x104, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_bbbb_oovv += einsum(x104, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x104
    x105 = np.zeros((nocc[1], nocc[1], nocc[1], nvir[1]), dtype=types[float])
    x105 += einsum(t1.bb, (0, 1), x50, (0, 2, 3, 4), (2, 4, 3, 1))
    del x50
    rdm2_f_bbbb_oovv += einsum(t1.bb, (0, 1), x105, (0, 2, 3, 4), (2, 3, 4, 1)) * -2.0
    del x105
    x106 = np.zeros((nocc[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    x106 += einsum(t1.aa, (0, 1), x1, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2_f_aaaa_ovov += einsum(x106, (0, 1, 2, 3), (1, 2, 0, 3)) * 2.0
    rdm2_f_aaaa_ovvo += einsum(x106, (0, 1, 2, 3), (1, 2, 3, 0)) * -2.0
    rdm2_f_aaaa_voov += einsum(x106, (0, 1, 2, 3), (2, 1, 0, 3)) * -2.0
    rdm2_f_aaaa_vovo += einsum(x106, (0, 1, 2, 3), (2, 1, 3, 0)) * 2.0
    x107 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x107 += einsum(l1.aa, (0, 1), t1.aa, (1, 2), (0, 2))
    x108 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x108 += einsum(x107, (0, 1), (0, 1))
    x108 += einsum(x71, (0, 1), (0, 1)) * 2.0
    x108 += einsum(x72, (0, 1), (0, 1))
    rdm2_f_aaaa_ovov += einsum(delta.aa.oo, (0, 1), x108, (2, 3), (0, 2, 1, 3))
    rdm2_f_aaaa_voov += einsum(delta.aa.oo, (0, 1), x108, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_abab_vovo += einsum(delta.bb.oo, (0, 1), x108, (2, 3), (2, 0, 3, 1))
    rdm2_f_abab_vovv += einsum(t1.bb, (0, 1), x108, (2, 3), (2, 0, 3, 1))
    x109 = np.zeros((nocc[0], nocc[0], nvir[1], nvir[1]), dtype=types[float])
    x109 += einsum(l2.abab, (0, 1, 2, 3), t2.abab, (4, 3, 0, 5), (2, 4, 1, 5))
    rdm2_f_abab_ovov += einsum(x109, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_abab_ovvv += einsum(t1.aa, (0, 1), x109, (0, 2, 3, 4), (2, 3, 1, 4)) * -1.0
    del x109
    x110 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x110 += einsum(l1.bb, (0, 1), t1.bb, (1, 2), (0, 2))
    x111 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x111 += einsum(x110, (0, 1), (0, 1))
    x111 += einsum(x82, (0, 1), (0, 1))
    x111 += einsum(x83, (0, 1), (0, 1)) * 2.0
    rdm2_f_abab_ovov += einsum(delta.aa.oo, (0, 1), x111, (2, 3), (0, 2, 1, 3))
    rdm2_f_bbbb_ovvo += einsum(delta.bb.oo, (0, 1), x111, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_bbbb_vovo += einsum(delta.bb.oo, (0, 1), x111, (2, 3), (2, 0, 3, 1))
    rdm2_f_abab_ovvv += einsum(t1.aa, (0, 1), x111, (2, 3), (0, 2, 1, 3))
    x112 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x112 += einsum(t1.bb, (0, 1), x16, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2_f_bbbb_ovov += einsum(x112, (0, 1, 2, 3), (1, 2, 0, 3)) * 2.0
    rdm2_f_bbbb_ovvo += einsum(x112, (0, 1, 2, 3), (1, 2, 3, 0)) * -2.0
    rdm2_f_bbbb_voov += einsum(x112, (0, 1, 2, 3), (2, 1, 0, 3)) * -2.0
    rdm2_f_bbbb_vovo += einsum(x112, (0, 1, 2, 3), (2, 1, 3, 0)) * 2.0
    x113 = np.zeros((nvir[1], nvir[1]), dtype=types[float])
    x113 += einsum(x110, (0, 1), (0, 1)) * 0.5
    del x110
    x113 += einsum(x82, (0, 1), (0, 1)) * 0.5
    del x82
    x113 += einsum(x83, (0, 1), (0, 1))
    del x83
    rdm2_f_bbbb_ovov += einsum(delta.bb.oo, (0, 1), x113, (2, 3), (0, 2, 1, 3)) * 2.0
    rdm2_f_bbbb_voov += einsum(delta.bb.oo, (0, 1), x113, (2, 3), (2, 0, 1, 3)) * -2.0
    del x113
    x114 = np.zeros((nvir[0], nvir[0]), dtype=types[float])
    x114 += einsum(x107, (0, 1), (0, 1)) * 0.5
    del x107
    x114 += einsum(x71, (0, 1), (0, 1))
    del x71
    x114 += einsum(x72, (0, 1), (0, 1)) * 0.5
    del x72
    rdm2_f_aaaa_ovvo += einsum(delta.aa.oo, (0, 1), x114, (2, 3), (0, 2, 3, 1)) * -2.0
    rdm2_f_aaaa_vovo += einsum(delta.aa.oo, (0, 1), x114, (2, 3), (2, 0, 3, 1)) * 2.0
    del x114
    x115 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x115 += einsum(t1.aa, (0, 1), x21, (0, 2, 3, 4), (2, 3, 1, 4))
    del x21
    rdm2_f_abab_ovvo += einsum(x115, (0, 1, 2, 3), (0, 3, 2, 1)) * -1.0
    x116 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x116 += einsum(l2.abab, (0, 1, 2, 3), t2.bbbb, (4, 3, 5, 1), (2, 4, 0, 5))
    rdm2_f_abab_voov += einsum(x116, (0, 1, 2, 3), (2, 1, 0, 3)) * 2.0
    x117 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x117 += einsum(t1.bb, (0, 1), x8, (2, 0, 3, 4), (2, 3, 4, 1))
    del x8
    rdm2_f_abab_voov += einsum(x117, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    x118 = np.zeros((nocc[0], nvir[0], nvir[0], nvir[0]), dtype=types[float])
    x118 += einsum(l1.aa, (0, 1), t2.aaaa, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2_f_aaaa_ovvv = np.zeros((nocc[0], nvir[0], nvir[0], nvir[0]), dtype=types[float])
    rdm2_f_aaaa_ovvv += einsum(x118, (0, 1, 2, 3), (0, 1, 3, 2)) * -2.0
    rdm2_f_aaaa_vovv = np.zeros((nvir[0], nocc[0], nvir[0], nvir[0]), dtype=types[float])
    rdm2_f_aaaa_vovv += einsum(x118, (0, 1, 2, 3), (1, 0, 3, 2)) * 2.0
    del x118
    x119 = np.zeros((nocc[0], nvir[0], nvir[0], nvir[0]), dtype=types[float])
    x119 += einsum(t2.aaaa, (0, 1, 2, 3), x1, (0, 1, 4, 5), (4, 5, 2, 3))
    del x1
    rdm2_f_aaaa_ovvv += einsum(x119, (0, 1, 2, 3), (0, 1, 3, 2)) * -2.0
    rdm2_f_aaaa_vovv += einsum(x119, (0, 1, 2, 3), (1, 0, 3, 2)) * 2.0
    del x119
    x120 = np.zeros((nocc[0], nvir[0], nvir[0], nvir[0]), dtype=types[float])
    x120 += einsum(t1.aa, (0, 1), x106, (0, 2, 3, 4), (2, 3, 4, 1)) * -1.0
    del x106
    rdm2_f_aaaa_ovvv += einsum(x120, (0, 1, 2, 3), (0, 1, 3, 2)) * -2.0
    rdm2_f_aaaa_vovv += einsum(x120, (0, 1, 2, 3), (1, 0, 3, 2)) * 2.0
    del x120
    x121 = np.zeros((nocc[0], nvir[0], nvir[0], nvir[0]), dtype=types[float])
    x121 += einsum(t1.aa, (0, 1), x78, (0, 2, 3, 4), (2, 1, 3, 4)) * 4.0
    del x78
    x122 = np.zeros((nocc[0], nvir[0], nvir[0], nvir[0]), dtype=types[float])
    x122 += einsum(x121, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    del x121
    x122 += einsum(t1.aa, (0, 1), x108, (2, 3), (0, 2, 1, 3))
    del x108
    rdm2_f_aaaa_ovvv += einsum(x122, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_aaaa_ovvv += einsum(x122, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_aaaa_vovv += einsum(x122, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_aaaa_vovv += einsum(x122, (0, 1, 2, 3), (1, 0, 3, 2))
    del x122
    x123 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x123 += einsum(x79, (0, 1, 2, 3), (0, 1, 2, 3))
    del x79
    x123 += einsum(x115, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    del x115
    x123 += einsum(x69, (0, 1, 2, 3), (0, 1, 2, 3))
    del x69
    rdm2_f_abab_ovvv += einsum(t1.bb, (0, 1), x123, (2, 0, 3, 4), (2, 4, 3, 1)) * 2.0
    del x123
    x124 = np.zeros((nocc[1], nvir[1], nvir[1], nvir[1]), dtype=types[float])
    x124 += einsum(l1.bb, (0, 1), t2.bbbb, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2_f_bbbb_ovvv = np.zeros((nocc[1], nvir[1], nvir[1], nvir[1]), dtype=types[float])
    rdm2_f_bbbb_ovvv += einsum(x124, (0, 1, 2, 3), (0, 1, 3, 2)) * -2.0
    rdm2_f_bbbb_vovv = np.zeros((nvir[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    rdm2_f_bbbb_vovv += einsum(x124, (0, 1, 2, 3), (1, 0, 3, 2)) * 2.0
    del x124
    x125 = np.zeros((nocc[1], nvir[1], nvir[1], nvir[1]), dtype=types[float])
    x125 += einsum(t2.bbbb, (0, 1, 2, 3), x16, (0, 1, 4, 5), (4, 5, 2, 3))
    del x16
    rdm2_f_bbbb_ovvv += einsum(x125, (0, 1, 2, 3), (0, 1, 3, 2)) * -2.0
    rdm2_f_bbbb_vovv += einsum(x125, (0, 1, 2, 3), (1, 0, 3, 2)) * 2.0
    del x125
    x126 = np.zeros((nocc[1], nvir[1], nvir[1], nvir[1]), dtype=types[float])
    x126 += einsum(t1.bb, (0, 1), x112, (0, 2, 3, 4), (2, 3, 4, 1)) * -1.0
    del x112
    rdm2_f_bbbb_ovvv += einsum(x126, (0, 1, 2, 3), (0, 1, 3, 2)) * -2.0
    rdm2_f_bbbb_vovv += einsum(x126, (0, 1, 2, 3), (1, 0, 3, 2)) * 2.0
    del x126
    x127 = np.zeros((nocc[1], nocc[1], nvir[1], nvir[1]), dtype=types[float])
    x127 += einsum(x91, (0, 1, 2, 3), (0, 1, 2, 3))
    del x91
    x127 += einsum(x100, (0, 1, 2, 3), (0, 1, 2, 3)) * 4.0
    del x100
    x128 = np.zeros((nocc[1], nvir[1], nvir[1], nvir[1]), dtype=types[float])
    x128 += einsum(t1.bb, (0, 1), x127, (0, 2, 3, 4), (2, 1, 3, 4))
    del x127
    x129 = np.zeros((nocc[1], nvir[1], nvir[1], nvir[1]), dtype=types[float])
    x129 += einsum(x128, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    del x128
    x129 += einsum(t1.bb, (0, 1), x111, (2, 3), (0, 2, 1, 3))
    del x111
    rdm2_f_bbbb_ovvv += einsum(x129, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_bbbb_ovvv += einsum(x129, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_bbbb_vovv += einsum(x129, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_bbbb_vovv += einsum(x129, (0, 1, 2, 3), (1, 0, 3, 2))
    del x129
    x130 = np.zeros((nocc[0], nocc[1], nvir[0], nvir[1]), dtype=types[float])
    x130 += einsum(x88, (0, 1, 2, 3), (0, 1, 2, 3))
    del x88
    x130 += einsum(x116, (0, 1, 2, 3), (0, 1, 2, 3))
    del x116
    x130 += einsum(x117, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    del x117
    rdm2_f_abab_vovv += einsum(t1.aa, (0, 1), x130, (0, 2, 3, 4), (3, 2, 1, 4)) * 2.0
    del x130
    x131 = np.zeros((nocc[0], nvir[0], nvir[0], nvir[0]), dtype=types[float])
    x131 += einsum(t1.aa, (0, 1), l2.aaaa, (2, 3, 4, 0), (4, 2, 3, 1))
    rdm2_f_aaaa_vvov = np.zeros((nvir[0], nvir[0], nocc[0], nvir[0]), dtype=types[float])
    rdm2_f_aaaa_vvov += einsum(x131, (0, 1, 2, 3), (2, 1, 0, 3)) * -2.0
    rdm2_f_aaaa_vvvo = np.zeros((nvir[0], nvir[0], nvir[0], nocc[0]), dtype=types[float])
    rdm2_f_aaaa_vvvo += einsum(x131, (0, 1, 2, 3), (2, 1, 3, 0)) * 2.0
    rdm2_f_aaaa_vvvv += einsum(t1.aa, (0, 1), x131, (0, 2, 3, 4), (2, 3, 1, 4)) * 2.0
    del x131
    x132 = np.zeros((nocc[0], nvir[0], nvir[1], nvir[1]), dtype=types[float])
    x132 += einsum(t1.bb, (0, 1), l2.abab, (2, 3, 4, 0), (4, 2, 3, 1))
    rdm2_f_abab_vvov = np.zeros((nvir[0], nvir[1], nocc[0], nvir[1]), dtype=types[float])
    rdm2_f_abab_vvov += einsum(x132, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_abab_vvvv += einsum(t1.aa, (0, 1), x132, (0, 2, 3, 4), (2, 3, 1, 4))
    del x132
    x133 = np.zeros((nocc[1], nvir[1], nvir[1], nvir[1]), dtype=types[float])
    x133 += einsum(t1.bb, (0, 1), l2.bbbb, (2, 3, 4, 0), (4, 2, 3, 1))
    rdm2_f_bbbb_vvov = np.zeros((nvir[1], nvir[1], nocc[1], nvir[1]), dtype=types[float])
    rdm2_f_bbbb_vvov += einsum(x133, (0, 1, 2, 3), (2, 1, 0, 3)) * -2.0
    rdm2_f_bbbb_vvvo = np.zeros((nvir[1], nvir[1], nvir[1], nocc[1]), dtype=types[float])
    rdm2_f_bbbb_vvvo += einsum(x133, (0, 1, 2, 3), (2, 1, 3, 0)) * 2.0
    rdm2_f_bbbb_vvvv += einsum(t1.bb, (0, 1), x133, (0, 2, 3, 4), (2, 3, 1, 4)) * 2.0
    del x133

    rdm2_f_aaaa = pack_2e(rdm2_f_aaaa_oooo, rdm2_f_aaaa_ooov, rdm2_f_aaaa_oovo, rdm2_f_aaaa_ovoo, rdm2_f_aaaa_vooo, rdm2_f_aaaa_oovv, rdm2_f_aaaa_ovov, rdm2_f_aaaa_ovvo, rdm2_f_aaaa_voov, rdm2_f_aaaa_vovo, rdm2_f_aaaa_vvoo, rdm2_f_aaaa_ovvv, rdm2_f_aaaa_vovv, rdm2_f_aaaa_vvov, rdm2_f_aaaa_vvvo, rdm2_f_aaaa_vvvv)
    rdm2_f_abab = pack_2e(rdm2_f_abab_oooo, rdm2_f_abab_ooov, rdm2_f_abab_oovo, rdm2_f_abab_ovoo, rdm2_f_abab_vooo, rdm2_f_abab_oovv, rdm2_f_abab_ovov, rdm2_f_abab_ovvo, rdm2_f_abab_voov, rdm2_f_abab_vovo, rdm2_f_abab_vvoo, rdm2_f_abab_ovvv, rdm2_f_abab_vovv, rdm2_f_abab_vvov, rdm2_f_abab_vvvo, rdm2_f_abab_vvvv)
    rdm2_f_bbbb = pack_2e(rdm2_f_bbbb_oooo, rdm2_f_bbbb_ooov, rdm2_f_bbbb_oovo, rdm2_f_bbbb_ovoo, rdm2_f_bbbb_vooo, rdm2_f_bbbb_oovv, rdm2_f_bbbb_ovov, rdm2_f_bbbb_ovvo, rdm2_f_bbbb_voov, rdm2_f_bbbb_vovo, rdm2_f_bbbb_vvoo, rdm2_f_bbbb_ovvv, rdm2_f_bbbb_vovv, rdm2_f_bbbb_vvov, rdm2_f_bbbb_vvvo, rdm2_f_bbbb_vvvv)

    rdm2_f_aaaa = rdm2_f_aaaa.swapaxes(1, 2)
    rdm2_f_aabb = rdm2_f_abab.swapaxes(1, 2)
    rdm2_f_bbbb = rdm2_f_bbbb.swapaxes(1, 2)

    rdm2_f.aaaa = rdm2_f_aaaa
    rdm2_f.aabb = rdm2_f_aabb
    rdm2_f.bbbb = rdm2_f_bbbb

    return rdm2_f

